SystemOrganization addCategory: #'Glamour-Morphic-Brick'!
SystemOrganization addCategory: 'Glamour-Morphic-Brick-Announcements'!
SystemOrganization addCategory: 'Glamour-Morphic-Brick-Layouts'!
SystemOrganization addCategory: 'Glamour-Morphic-Brick-Model'!
SystemOrganization addCategory: 'Glamour-Morphic-Brick-Renderer'!
SystemOrganization addCategory: 'Glamour-Morphic-Brick-UI'!
SystemOrganization addCategory: 'Glamour-Morphic-Brick-Utils'!
SystemOrganization addCategory: 'Glamour-Morphic-Brick-Widgets'!

TableLayoutProperties subclass: #GLMBrickLayoutProperties
	instanceVariableNames: 'marginTop marginRight marginBottom marginLeft paddingTop paddingRight paddingBottom paddingLeft horizontalPercent verticalPercent maxWidthBlock maxHeightBlock minHeightBlock minWidthBlock floating zIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Layouts'!

!GLMBrickLayoutProperties commentStamp: 'AliakseiSyrel 10/17/2014 10:13' prior: 0!
A GLMBrickLayoutProperties is  a holder class of layout properties used by layout policy

Instance Variables
	horizontalPercent:		<Object>
	marginBottom:		<Object>
	marginLeft:		<Object>
	marginRight:		<Object>
	marginTop:		<Object>
	maxHeightBlock:		<Object>
	maxWidthBlock:		<Object>
	minHeight:		<Object>
	minWidth:		<Object>
	paddingBottom:		<Object>
	paddingLeft:		<Object>
	paddingRight:		<Object>
	paddingTop:		<Object>
	verticalPercent:		<Object>

horizontalPercent
	- xxxxx

marginBottom
	- xxxxx

marginLeft
	- xxxxx

marginRight
	- xxxxx

marginTop
	- xxxxx

maxHeightBlock
	- xxxxx

maxWidthBlock
	- xxxxx

minHeight
	- xxxxx

minWidth
	- xxxxx

paddingBottom
	- xxxxx

paddingLeft
	- xxxxx

paddingRight
	- xxxxx

paddingTop
	- xxxxx

verticalPercent
	- xxxxx
!

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/19/2014 19:47'!
floating
	^ floating! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/19/2014 19:47'!
floating: aSymbol
	floating := aSymbol! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/23/2014 19:18'!
horizontalMargin

	^ self marginLeft + self marginRight! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/22/2014 15:21'!
horizontalPadding

	^ self paddingLeft + self paddingRight! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/3/2014 20:09'!
horizontalPercent
	^ horizontalPercent! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/3/2014 20:09'!
horizontalPercent: anObject
	horizontalPercent := anObject! !

!GLMBrickLayoutProperties methodsFor: 'initialization' stamp: 'AliakseiSyrel 11/27/2014 20:49'!
initialize
	super initialize.
	
	marginBottom := 0.
	marginLeft := 0.
	marginRight := 0.
	marginTop := 0.
	paddingBottom := 0.
	paddingLeft := 0.
	paddingRight := 0.
	paddingTop := 0.
	horizontalPercent := 25.
	verticalPercent := 25.
	zIndex := 1. "the lowest one"
	maxWidthBlock := [ :aTrick | -1 ]. "negative value means undefined"
	maxHeightBlock := [ :aTrick | -1 ]. "negative value means undefined"
	minWidthBlock := [ :aTrick | -1 ]. "negative value means undefined"
	minHeightBlock := [ :aTrick | -1 ]. "negative value means undefined"
	floating := #none! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/3/2014 19:26'!
marginBottom
	^ marginBottom! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/3/2014 19:26'!
marginBottom: anObject
	marginBottom := anObject! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/3/2014 19:26'!
marginLeft
	^ marginLeft! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/3/2014 19:27'!
marginLeft: anObject
	marginLeft := anObject! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/3/2014 19:27'!
marginRight
	^ marginRight! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/3/2014 19:27'!
marginRight: anObject
	marginRight := anObject! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/3/2014 19:27'!
marginTop
	^ marginTop! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/3/2014 19:27'!
marginTop: anObject
	marginTop := anObject! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/22/2014 16:48'!
maxHeight: anObject
	maxHeightBlock := [ anObject ]! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 14:50'!
maxHeightBlock
	^ maxHeightBlock! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 14:50'!
maxHeightBlock: anObject
	maxHeightBlock := anObject! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/22/2014 16:48'!
maxWidth: anObject
	maxWidthBlock := [ anObject ]! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 14:50'!
maxWidthBlock
	^ maxWidthBlock! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 14:50'!
maxWidthBlock: anObject
	maxWidthBlock := anObject! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/22/2014 16:48'!
minHeight: anObject
	minHeightBlock := [ anObject ]! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/22/2014 13:03'!
minHeightBlock
	^ minHeightBlock! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/22/2014 13:03'!
minHeightBlock: anObject
	minHeightBlock := anObject! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/22/2014 16:48'!
minWidth: anObject
	minWidthBlock := [ anObject ]! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/22/2014 13:03'!
minWidthBlock
	^ minWidthBlock! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/22/2014 13:03'!
minWidthBlock: anObject
	minWidthBlock := anObject! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 14:30'!
paddingBottom
	^ paddingBottom! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 14:30'!
paddingBottom: anObject
	paddingBottom := anObject! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 14:30'!
paddingLeft
	^ paddingLeft! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 14:30'!
paddingLeft: anObject
	paddingLeft := anObject! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 14:30'!
paddingRight
	^ paddingRight! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 14:30'!
paddingRight: anObject
	paddingRight := anObject! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 14:30'!
paddingTop
	^ paddingTop! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 14:30'!
paddingTop: anObject
	paddingTop := anObject! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/23/2014 19:18'!
verticalMargin

	^ self marginTop + self marginBottom! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/22/2014 15:21'!
verticalPadding

	^ self paddingTop + self paddingBottom! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/3/2014 20:09'!
verticalPercent
	^ verticalPercent! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/3/2014 20:09'!
verticalPercent: anObject
	verticalPercent := anObject! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/27/2014 20:49'!
zIndex
	^ zIndex! !

!GLMBrickLayoutProperties methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/27/2014 20:49'!
zIndex: anObject
	zIndex := anObject! !

Morph subclass: #GLMBrick
	instanceVariableNames: 'renderer data brickBounds brickOwner brickRoot subbricks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-UI'!

!GLMBrick commentStamp: 'AliakseiSyrel 10/17/2014 10:09' prior: 0!
A GLMBrick is the main Brick class. Can hold another Bricks and contains logic of rendering, positioning bricks and also possibilities to interate with them using mouse or keyboard.

The idea of this project is to boost  performance of complicated glamour widgets where smooth and fast work is neccessary.

Instance Variables
	data:		<Object>
	renderer:		<Object>
	subbricks:		<Object>
	brickBounds:		<Object>
	brickOwner:		<Object>
	brickRoot:		<Object>

data
	- xxxxx

renderer
	- xxxxx

subbricks
	- xxxxx

brickBounds
	- xxxxx

brickOwner
	- xxxxx

brickRoot
	- xxxxx
!

GLMBrick subclass: #GLMBandBrick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-UI'!

!GLMBandBrick commentStamp: 'AliakseiSyrel 10/18/2014 00:57' prior: 0!
A GLMBandBrick is a simple Brick with height and bounds to fit all subbricks.
Usually used within scroll panes
!

!GLMBandBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 11/30/2014 19:58'!
doLayout
	
	self layoutChildren.

	self subbricks do: [ :each | each isBrick ifTrue: [ each doLayout ] ]! !

!GLMBandBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 11/27/2014 13:14'!
height
	|height|
	self heightBlock ifNotNil: [ ^ self heightBlock cull: self ].
		
	height := self layoutProperties verticalPadding.
	self subbricks do: [ :each | height := height + each height + each layoutProperties verticalMargin ].
	^ height! !

!GLMBandBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 10/17/2014 23:02'!
initialize
	super initialize.
	
	self layoutPolicy: GLMBrickVerticalFillLinearLayout new.! !

!GLMBandBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 11/30/2014 20:42'!
layoutChildren

	|mBounds mOwner|
	"most of the time you don't want to call this method manually"
	"nice example to check is GLMLabelBrick>>doLayout"
	
	mOwner := self owner ifNil: [ self ] ifNotNil: [ self owner ].
	mBounds := mOwner isBrick ifTrue: [ mOwner brickGlobalInnerBounds ] ifFalse: [ mOwner globalBounds ].
	
	^ self layoutPolicy layout: self in: mBounds.! !

GLMBandBrick subclass: #GLMMorphBrick
	instanceVariableNames: 'morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Widgets'!

!GLMMorphBrick commentStamp: 'AliakseiSyrel 12/6/2014 18:16' prior: 0!
A GLMMorphBrick is used as container for morphs to embed them inside bricks

Instance Variables
	morph:		<Object>

morph
	- xxxxx
!

!GLMMorphBrick class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/6/2014 17:02'!
on: aMorph

	^ self new on: aMorph! !

!GLMMorphBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/6/2014 17:06'!
doLayout
	
	self layoutPolicy layout: self in: self brickBounds! !

!GLMMorphBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/6/2014 17:03'!
initialize
	super initialize.! !

!GLMMorphBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/6/2014 17:13'!
morph

	^ morph! !

!GLMMorphBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/6/2014 17:04'!
on: aMorph

	morph := aMorph.
	morph layoutProperties: (GLMBrickLayoutProperties new).
	morph layoutProperties horizontalPercent: 100.
	morph layoutProperties verticalPercent: 100.
	self addBrickBack: morph! !

!GLMBrick class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 11/27/2014 21:02'!
exampleZindex

	"self exampleZindex"

	|foundationBrick rootBrick brick1 brick2 brick3|
	
	rootBrick := GLMBrick new.
	rootBrick layoutPolicy: GLMBrickNoLayout new.

	rootBrick color: Color blue.
	
	brick1 := GLMBrick new.
	brick1 color: Color red.
	brick1 brickBounds: (0@0 extent: 300@200).
	brick1 layoutProperties zIndex: 1.
	
	brick2 := GLMBrick new.
	brick2 color: Color green.
	brick2 brickBounds: (50@50 extent: 200@100).
	brick2 layoutProperties zIndex: 2.
	
	brick3 := GLMBrick new.
	brick3 color: Color yellow.
	brick3 brickBounds: (100@100 extent: 100@100).
	brick3 layoutProperties zIndex: 3.
	
	rootBrick
		addBrickBack: brick3;
		addBrickBack: brick2;
		addBrickBack: brick1.
		
	foundationBrick := GLMFoundationBrick new.
	foundationBrick brickRoot: rootBrick.
	foundationBrick openInWindow.
	foundationBrick color: Color pink.! !

!GLMBrick class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 11/27/2014 18:34'!
morphInsideBrickExample

	"self morphInsideBrickExample"

	|foundation brick morph|
	
	foundation := GLMFoundationBrick new.
	foundation extent: 800@400.

	brick := GLMLabelBrick new.
	brick text: 'Hello, I''m a Brick inside another Brick!!'.
	brick layoutProperties horizontalPercent: 50.
	brick color: Color lightBlue lighter.

	morph := Morph new.
	morph color: Color lightGreen lighter.
	morph layoutProperties: GLMBrickLayoutProperties new.
	morph layoutProperties horizontalPercent: 50.

	morph addMorphBack: (LabelMorph new
		contents: 'Hello, I''m a Morph inside another Morph inside Brick!!';
		hResizing: #spaceFill;
		vResizing: #spaceFill).

	foundation
		addBrickBack: brick;
		addBrickBack: morph;
		doLayout;
		openInWindow.! !

!GLMBrick class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/4/2014 13:29'!
resizeImage: anImage scale: aScale

	((aScale > (1@0)) | (aScale > (0@1))) ifTrue: [
		^ GLMForm increaseFormExtentCentered: anImage to: (anImage extent * aScale).
	].

	aScale = (1@1) ifTrue: [
		^ anImage
	].
	
	^ anImage magnify: anImage boundingBox by: aScale smoothing: 2.! !

!GLMBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 10/17/2014 09:48'!
addAllBricks: aCollection

	aCollection do: [ :each | self addBrickBack: each ]! !

!GLMBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 12/5/2014 23:32'!
addBrick: aBrick before: anotherBrick
	|link|
	
	link := self privateSubbricks add: aBrick beforeLink: anotherBrick privateBrickDoubleLink.
	aBrick privateBrickDoubleLink: link.
	self initializeBrick: aBrick.
	super addMorph: aBrick inFrontOf: anotherBrick.
	^ aBrick! !

!GLMBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 12/5/2014 23:31'!
addBrickBack: aBrick
	|link|
	
	link := self privateSubbricks add: aBrick.
	aBrick privateBrickDoubleLink: link.
	
	self initializeBrick: aBrick.
	super addMorphBack: aBrick.
	^ aBrick! !

!GLMBrick methodsFor: 'layout morph' stamp: 'AliakseiSyrel 12/2/2014 20:17'!
adjustLayoutBounds
	"no need in it"! !

!GLMBrick methodsFor: 'converting' stamp: 'AliakseiSyrel 12/6/2014 17:10'!
asBrick
	^ self! !

!GLMBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 10/11/2014 00:41'!
bounds

	^ self globalBounds! !

!GLMBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 10/17/2014 10:39'!
bounds: newBounds

	self brickBounds: (
		self brickOwner
			ifNotNil: [ newBounds translateBy: (self brickOwner globalBounds origin negated) ]
			ifNil: [ newBounds ] )! !

!GLMBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 10/17/2014 09:56'!
brickBounds
	^ brickBounds! !

!GLMBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 11/22/2014 14:53'!
brickBounds: aRectangle
	"if you want to change brick's position or bounds use only this method!!"
	
	brickBounds := aRectangle.
	
	bounds := self bounds.
	fullBounds := bounds! !

!GLMBrick methodsFor: 'private' stamp: 'AliakseiSyrel 11/22/2014 14:42'!
brickGlobalInnerBounds

	^ self brickOwner
		ifNotNil: [ self brickInnerBounds translateBy: brickOwner globalBounds origin ]
		ifNil: [ super bounds ]
! !

!GLMBrick methodsFor: 'private' stamp: 'AliakseiSyrel 10/17/2014 09:56'!
brickGlobalOuterBounds

	^ self brickOwner
		ifNotNil: [ self brickOuterBounds translateBy: brickOwner globalBounds origin ]
		ifNil: [ super bounds ]
! !

!GLMBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 11/22/2014 13:53'!
brickInnerBounds

	^ (self brickBounds origin + ((self layoutProperties paddingLeft) @ (self layoutProperties paddingTop)))
		corner: (self brickBounds corner - ((self layoutProperties paddingRight) @ (self layoutProperties paddingBottom))).! !

!GLMBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 11/22/2014 14:54'!
brickOuterBounds

	^ (self brickBounds origin - ((self layoutProperties marginLeft) @ (self layoutProperties marginTop)))
		corner: (self brickBounds corner + ((self layoutProperties marginRight) @ (self layoutProperties marginBottom))).

! !

!GLMBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/17/2014 09:56'!
brickOwner
	^ brickOwner! !

!GLMBrick methodsFor: 'private' stamp: 'AliakseiSyrel 10/17/2014 10:44'!
brickOwner: aBrick
	"never ever use this method"
	
	brickOwner := aBrick! !

!GLMBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/17/2014 09:57'!
brickRoot

	^ brickRoot! !

!GLMBrick methodsFor: 'private' stamp: 'AliakseiSyrel 10/22/2014 23:34'!
brickRoot: aGLMFoundationBrick
	"never ever use this method"
	
	brickRoot := aGLMFoundationBrick.
	
	self subbricks do: [ :each | each isBrick ifTrue: [ each brickRoot: brickRoot ] ]! !

!GLMBrick methodsFor: 'drawing' stamp: 'AliakseiSyrel 10/18/2014 14:01'!
changed
	"Report that the area occupied by this morph should be redrawn.
	Fixed to include submorphs outside the outerBounds."
	
	"fixed direct reference to fullBounds, causing wrong results, because fullBounds are not being updated when parent's or child's bounds changed"
	^ self fullBounds 
		ifNil: [self invalidRect: self privateFullBounds]
		ifNotNil: [self invalidRect: self fullBounds]! !

!GLMBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 10/18/2014 13:52'!
clippingBounds

	^ self fullBounds! !

!GLMBrick methodsFor: 'layout morph' stamp: 'AliakseiSyrel 10/18/2014 14:15'!
computeBounds
	"nothing to compute, everything is already computed"! !

!GLMBrick methodsFor: 'layout morph' stamp: 'AliakseiSyrel 10/18/2014 14:15'!
computeFullBounds
	"nothing to compute, everything is already computed"! !

!GLMBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 16:22'!
data

	^ data! !

!GLMBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/17/2014 10:11'!
data: anObject
	data := anObject.
	
	self announcer announce: GLMBrickDataChanged new.! !

!GLMBrick methodsFor: 'layout brick' stamp: 'AliakseiSyrel 10/18/2014 14:13'!
doLayout
	"most of the time you don't want to call this method manually"
	"nice example to check is GLMLabelBrick>>doLayout"
	
	self layoutPolicy layout: self in: self bounds.
	
	subbricks do: [ :each | each isBrick ifTrue: [ each doLayout ] ]
	! !

!GLMBrick methodsFor: 'layout morph' stamp: 'AliakseiSyrel 12/2/2014 20:22'!
doLayoutIn: layoutBounds
	"we remove morphic layouting mechanism"! !

!GLMBrick methodsFor: 'drawing' stamp: 'AliakseiSyrel 10/24/2014 16:00'!
drawOn: aCanvas
	super drawOn: aCanvas.
	
	"translating canvas coordinates"
	 (aCanvas isKindOf: ClippingCanvas) ifTrue: [ ^self "no need to draw anything" ].
	self onDraw: ( aCanvas copy setOrigin: (aCanvas origin + self globalBounds origin - self brickBounds origin) clipRect: (aCanvas clipRect translateBy: aCanvas origin))! !

!GLMBrick methodsFor: 'drawing' stamp: 'AliakseiSyrel 11/27/2014 20:54'!
drawSubmorphsOn: aCanvas
	| area zIndexedBricks |
	
	self submorphs isEmpty ifTrue: [ ^ self ].

	"make sure my children will not go away of my inner bounds (we take care about paddings)"
	area := aCanvas clipRect intersect: self brickGlobalInnerBounds ifNone: (0 @ 0 extent: 0 @ 0).
	"do smart drawing logic here"
	area width = 0 | (area height = 0) ifTrue: [ 
			"draw nothing"
			^ self ].
	
	zIndexedBricks := OrderedCollection new.
	
	self subbricks
		do: [ :each | 
			| intersection canvas globalBounds |
			globalBounds := each isBrick
				ifTrue: [ each globalBounds ]
				ifFalse: [ each fullBounds ].
				
			(area intersects: globalBounds) ifTrue: [
				| zIndex |
				zIndex := each layoutProperties zIndex.
				zIndex = 1 ifTrue: [
					"immediately draw ones with the lowest possible z-index.
					With this approach performance doesn't degrade"
					intersection := area intersect: globalBounds ifNone: (0 @ 0 extent: 0 @ 0).
					canvas := aCanvas copyClipRect: intersection.
					each fullDrawOn: canvas ]
					"if z-index is not 1 we add it to collection, in order to sort and draw as second attempt"
				ifFalse: [ zIndexedBricks add: each ] ] ].
		
		"z-index drawing section"
		zIndexedBricks sort: [ :first :second | first layoutProperties zIndex < second layoutProperties zIndex ].
		
		zIndexedBricks do: [ :each |
			| intersection canvas globalBounds |
			globalBounds := each isBrick
				ifTrue: [ each globalBounds ]
				ifFalse: [ each fullBounds ].
				
			intersection := area intersect: globalBounds ifNone: (0 @ 0 extent: 0 @ 0).
			canvas := aCanvas copyClipRect: intersection.
			each fullDrawOn: canvas ]
		! !

!GLMBrick methodsFor: 'drawing' stamp: 'AliakseiSyrel 10/17/2014 09:56'!
extent

	^ self brickBounds extent! !

!GLMBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 10/18/2014 16:52'!
extent: aPoint
	"to change brick's size use only this method!!"
	
	self brickBounds: (self brickBounds origin extent: aPoint)! !

!GLMBrick methodsFor: 'submorphs-accessing' stamp: 'AliakseiSyrel 12/2/2014 17:36'!
firstSubbrick

	^ self subbricks first! !

!GLMBrick methodsFor: 'layout morph' stamp: 'AliakseiSyrel 10/18/2014 01:08'!
fullBounds

	^ self globalBounds! !

!GLMBrick methodsFor: 'drawing' stamp: 'AliakseiSyrel 10/18/2014 00:22'!
fullDrawOn: aCanvas
	"fixes bug in canvas, when it tries to draw a morph even if clip rect has size 0"
	aCanvas clipRect width = 0 | (aCanvas clipRect height = 0) ifTrue: [ ^ self ].
	super fullDrawOn: aCanvas.! !

!GLMBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 12/2/2014 18:49'!
globalBounds
	"converts brickBounds to morhic bounds on fly"
	"if you want to implement something sophisticated that combines bricks and morphic this is right method to use"
	^ self brickOwner ifNotNil: [ self brickBounds translateBy: self brickOwner globalBoundsTranslateFactor ] ifNil: [ 0@0 extent: 20@20 ].! !

!GLMBrick methodsFor: 'private' stamp: 'AliakseiSyrel 10/17/2014 09:55'!
globalBoundsOfArea: aRectangle

	^ aRectangle translateBy: brickOwner globalBounds origin
	! !

!GLMBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 12/2/2014 18:48'!
globalBoundsTranslateFactor

	^ self brickOwner ifNotNil: [ brickOwner globalBoundsTranslateFactor + self brickBounds origin ] ifNil: [ 0@0 ]! !

!GLMBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 11/27/2014 11:51'!
height

	^ self heightBlock
		ifNotNil: [ self heightBlock cull: self ]
		ifNil: [ self privateHeight ]! !

!GLMBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/23/2014 18:44'!
heightBlock

	^ self valueOfProperty: #brickHeightBlock ifAbsentPut: [ nil ]! !

!GLMBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/23/2014 18:43'!
heightBlock: aBlock
	"you can use a block to 'fake' a height or replace it's calculation logic without extending a brick"
	self setProperty: #brickHeightBlock toValue: aBlock! !

!GLMBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 11/27/2014 17:44'!
initialize
	super initialize.
	
	subbricks := GLMBrickDoubleLinkedList new.
	
	self layoutProperties: GLMBrickLayoutProperties new.
	self layoutPolicy: GLMBrickHorizontalFillProportionalLinearLayout new.
	self renderer: GLMBrickRenderer.
	self brickRoot: self.
	
	brickBounds := 0@0 extent: 50@50.
	
	self beTransparent! !

!GLMBrick methodsFor: 'initialization' stamp: 'AliaskeiSyrel 11/8/2014 17:19'!
initializeBrick: aBrick
	
	aBrick isBrick ifTrue: [
		aBrick brickRoot: self brickRoot.
		aBrick brickOwner: self ]! !

!GLMBrick methodsFor: 'testing' stamp: 'AliakseiSyrel 10/17/2014 15:26'!
isBrick
	^ true! !

!GLMBrick methodsFor: 'testing' stamp: 'AliakseiSyrel 12/2/2014 17:26'!
isFirstInOwner

	^ self privateBrickDoubleLink hasPredecessor not! !

!GLMBrick methodsFor: 'testing' stamp: 'AliakseiSyrel 10/17/2014 09:56'!
isFitsInParent

	^ self brickOwner
		"if our owner is a trick"
		ifNotNil: [ self brickOwner globalBounds containsRect: self globalBounds ]
		"if our owner is a morph"
		ifNil: [ self owner ifNotNil: [ self owner bounds containsRect: self globalBounds ] ifNil: [ ^ true ] ]! !

!GLMBrick methodsFor: 'testing' stamp: 'AliakseiSyrel 12/2/2014 17:26'!
isLastInOwner

	^ self privateBrickDoubleLink hasSuccessor not! !

!GLMBrick methodsFor: 'submorphs-accessing' stamp: 'AliakseiSyrel 12/2/2014 17:36'!
lastSubbrick

	^ self subbricks last! !

!GLMBrick methodsFor: 'layout morph' stamp: 'AliakseiSyrel 12/2/2014 20:25'!
layoutBounds: aRectangle
	"I'm not a morph anymore"! !

!GLMBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 11/27/2014 18:28'!
layoutChanged

	"empty"! !

!GLMBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/6/2014 17:13'!
morph
	^ self! !

!GLMBrick methodsFor: 'drawing' stamp: 'AliakseiSyrel 10/11/2014 01:38'!
onDraw: aCanvas

	self renderer render: self on: aCanvas. ! !

!GLMBrick methodsFor: 'layout brick' stamp: 'AliakseiSyrel 12/1/2014 17:29'!
onLayoutEvent: aLayoutEvent
	"in case layout want's to trigger any specific event"! !

!GLMBrick methodsFor: 'layout brick' stamp: 'AliakseiSyrel 12/1/2014 17:29'!
onPrepareLayout
	"is called before I'm started layouting"! !

!GLMBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 10/18/2014 13:55'!
outerBounds
	^ self fullBounds! !

!GLMBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 12/2/2014 20:32'!
privateFullBounds
	^ self fullBounds! !

!GLMBrick methodsFor: 'private' stamp: 'AliakseiSyrel 11/22/2014 14:54'!
privateHeight

	^ self brickBounds height! !

!GLMBrick methodsFor: 'change reporting' stamp: 'AliakseiSyrel 11/27/2014 18:22'!
privateInvalidateMorph: aMorph
	"empty"! !

!GLMBrick methodsFor: 'private' stamp: 'AliakseiSyrel 11/22/2014 17:11'!
privateSubbricks
	^ subbricks! !

!GLMBrick methodsFor: 'private' stamp: 'AliakseiSyrel 11/22/2014 14:55'!
privateWidth

	^ self brickBounds width! !

!GLMBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 10/17/2014 09:56'!
relativeBounds

	^ self brickBounds translateBy: brickOwner relativeBounds origin! !

!GLMBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 11/27/2014 17:59'!
removeAllBricks

	self privateSubbricks do: [ :each |
		each privateBrickDoubleLink: nil.
		each isBrick ifTrue: [
			each brickRoot: nil.
			each brickOwner: nil ] ].
	
	self privateSubbricks removeAll.
	self removeAllMorphs! !

!GLMBrick methodsFor: 'submorphs-add/remove' stamp: 'AliakseiSyrel 12/2/2014 19:58'!
removeAllMorphs
	| oldMorphs myWorld |
	"we don't invalidate world"
	myWorld := self world.
	submorphs do: [:m | myWorld ifNotNil: [ m outOfWorld: myWorld ]. m privateOwner: nil].
	oldMorphs := submorphs.
	submorphs := EmptyArray.
	oldMorphs do: [ :m | self removedMorph: m ].
! !

!GLMBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 11/27/2014 17:59'!
removeBrick: aBrick
	
	aBrick isBrick ifTrue: [
		aBrick brickRoot: nil.
		aBrick brickOwner: nil.
	].
	
	self removeMorph: aBrick.
	self privateSubbricks removeLink: aBrick privateBrickDoubleLink.
	aBrick privateBrickDoubleLink: nil.
	^ aBrick! !

!GLMBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 13:59'!
renderer

	^ renderer! !

!GLMBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 13:59'!
renderer: aRenderer

	renderer := aRenderer! !

!GLMBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/17/2014 09:58'!
subbricks

	^ subbricks! !

!GLMBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/27/2014 18:15'!
subbricksCount

	^ self submorphCount! !

!GLMBrick methodsFor: 'submorphs-accessing' stamp: 'AliakseiSyrel 11/27/2014 18:14'!
submorphAfter

	"Return the submorph after (behind) me, or nil"
	| link |
	link := self privateBrickDoubleLink.
	link ifNil: [ ^ nil ].
	link nextLink ifNil: [ ^ nil ].
	^ link nextLink value! !

!GLMBrick methodsFor: 'submorphs-accessing' stamp: 'AliakseiSyrel 11/27/2014 18:16'!
submorphBefore

	"Return the submorph before me, or nil"
	| link |
	link := self privateBrickDoubleLink.
	link ifNil: [ ^ nil ].
	link previousLink ifNil: [ ^ nil ].
	^ link previousLink value! !

!GLMBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 11/27/2014 11:50'!
width

	^ self widthBlock
		ifNotNil: [ self widthBlock cull: self ]
		ifNil: [ self privateWidth ]! !

!GLMBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/23/2014 18:45'!
widthBlock

	^ self valueOfProperty: #brickWidthBlock ifAbsentPut: [ nil ]! !

!GLMBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/23/2014 18:45'!
widthBlock: aBlock
	"you can use a block to 'fake' a width or replace it's calculation logic without extending a brick"
	self setProperty: #brickWidthBlock toValue: aBlock! !

GLMBrick subclass: #GLMGeneralScrollPaneBrick
	instanceVariableNames: 'band lastScrollTimeStamp currentVelocity verticalScrollbar scrollPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-UI'!

!GLMGeneralScrollPaneBrick commentStamp: 'AliakseiSyrel 12/5/2014 06:57' prior: 0!
A GLMGeneralScrollPaneBrick is an abstract scroll pane implementation, that takes controll of keyboard and mouse events

Instance Variables
	band:		<Object>
	currentVelocity:		<Object>
	lastScrollTimeStamp:		<Object>
	scrollPosition:		<Object>
	verticalScrollbar:		<Object>

band
	- xxxxx

currentVelocity
	- xxxxx

lastScrollTimeStamp
	- xxxxx

scrollPosition
	- xxxxx

verticalScrollbar
	- xxxxx
!

!GLMGeneralScrollPaneBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 12/5/2014 06:52'!
addBrick: aBrick before: anotherBrick
	band addBrick: aBrick before: anotherBrick! !

!GLMGeneralScrollPaneBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 12/5/2014 06:52'!
addBrickBack: aBrick
	band addBrickBack: aBrick! !

!GLMGeneralScrollPaneBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/5/2014 06:52'!
allowedBounds

	^ self globalBounds! !

!GLMGeneralScrollPaneBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/5/2014 06:52'!
band

	^ band! !

!GLMGeneralScrollPaneBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/5/2014 06:52'!
calculateMaxVelocity

	"max velocity must depend from the height of the band"
	^ (self band height / 15) max: self class defaultMaxVelocity! !

!GLMGeneralScrollPaneBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/5/2014 06:52'!
calculateVelocity: event
	|delta|
	delta := event timeStamp - lastScrollTimeStamp.
		
	delta > self class defaultScrollTimeReset
		ifTrue: [ currentVelocity := self class defaultScrollVelocity ]
		ifFalse: [ currentVelocity := (currentVelocity + self class defaultScrollAcceleration * (delta <= self class defaultScrollTurboTime ifTrue: [ 2 ] ifFalse: [ 1 ] )) min: self calculateMaxVelocity ].
		
	lastScrollTimeStamp := event timeStamp.
	
	^ currentVelocity ceiling! !

!GLMGeneralScrollPaneBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/5/2014 06:52'!
defaultScrollbarPosition

	^ #right! !

!GLMGeneralScrollPaneBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/5/2014 06:52'!
defaultScrollbarWidth

	^ 5! !

!GLMGeneralScrollPaneBrick methodsFor: 'layouting' stamp: 'AliakseiSyrel 12/5/2014 06:55'!
doLayout
	super doLayout.
	
	self band brickBounds: (self band brickBounds translateBy: (0@(self scrollPositionTop - self band brickBounds top))).
	
	self update! !

!GLMGeneralScrollPaneBrick methodsFor: 'mouse events' stamp: 'AliakseiSyrel 12/5/2014 06:52'!
handleListenEvent: anEvent
	
	"checking if it's keyboard event (mouse wheel is keyboard event on windows o_O (wtf?)"
	anEvent type = #keystroke ifTrue: [
		"checking if mouse is inside me"
		((self boundsInWorld containsPoint: anEvent position)) ifTrue: [
			"actuall scrolling"
			self scrollByKeyboard: anEvent ] ]! !

!GLMGeneralScrollPaneBrick methodsFor: 'mouse events' stamp: 'AliakseiSyrel 12/5/2014 06:52'!
handlesMouseWheel: evt
	^ true! !

!GLMGeneralScrollPaneBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 12/5/2014 06:54'!
initialize
	super initialize.
	
	lastScrollTimeStamp := 0.
	currentVelocity := self class defaultScrollVelocity.
	scrollPosition := 0.
	
	band := self newBand.
	
	self layoutPolicy: GLMBrickVerticalFillLinearLayout new.
	super addBrickBack: band.
	
	self verticalScrollbar: self newVerticalScrollbar.
	
	"initializes listener for mouse wheel scroll on windows vm"
	self initializeListeners.! !

!GLMGeneralScrollPaneBrick methodsFor: 'initialize' stamp: 'AliakseiSyrel 12/5/2014 06:52'!
initializeListeners

	"using the most general event subscribtion for all events spawned by the hand"
	self activeHand addEventListener: self.! !

!GLMGeneralScrollPaneBrick methodsFor: 'testing' stamp: 'AliakseiSyrel 12/5/2014 06:52'!
isKeyboardScrollEvent: anEvent

	(anEvent controlKeyPressed | anEvent commandKeyPressed) ifFalse: [^ false ].
	anEvent keyValue = 30 ifTrue: [ ^ true ].
	anEvent keyValue = 31 ifTrue: [ ^ true ].
	^ false! !

!GLMGeneralScrollPaneBrick methodsFor: 'testing' stamp: 'AliakseiSyrel 12/5/2014 23:10'!
isPartiallyVisible: aBrick
	|myBounds testingBounds|
	"need to normalize bounds to take only y coordinate into account"
	
	myBounds := (self allowedBounds withWidth: 1) translateBy: (self allowedBounds origin negated x@0).
	testingBounds :=  (aBrick globalBounds withWidth: 1) translateBy: (aBrick globalBounds origin negated x@0).
	
	^ myBounds intersects: testingBounds! !

!GLMGeneralScrollPaneBrick methodsFor: 'testing' stamp: 'AliakseiSyrel 12/5/2014 06:53'!
isVisible: aBrick
	|myBounds testingBounds|
	"need to normalize bounds to take only y coordinate into account"
	
	myBounds := (self allowedBounds withWidth: 0) translateBy: (self allowedBounds origin negated x@0).
	testingBounds :=  (aBrick globalBounds withWidth: 0) translateBy: (aBrick globalBounds origin negated x@0).
	
	^ myBounds containsRect: testingBounds! !

!GLMGeneralScrollPaneBrick methodsFor: 'mouse events' stamp: 'AliakseiSyrel 12/5/2014 06:53'!
mouseWheel: event
	|velocity|
	
	velocity := self calculateVelocity: event.
	
	event direction = #up
		ifTrue: [ self scrollUp: velocity ].
		
	event direction = #down
		ifTrue: [ self scrollDown: velocity ].
	
	scrollPosition := band brickBounds top.
	
	self update.
	self changed! !

!GLMGeneralScrollPaneBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 12/5/2014 06:53'!
newBand

	^ GLMBandBrick new! !

!GLMGeneralScrollPaneBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 12/5/2014 06:53'!
newVerticalScrollbar
	^ GLMScrollbarBrick new! !

!GLMGeneralScrollPaneBrick methodsFor: 'initialize' stamp: 'AliakseiSyrel 12/5/2014 06:53'!
outOfWorld: aWorld
	super outOfWorld: aWorld.
	
	self unsubscribeListeners! !

!GLMGeneralScrollPaneBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 12/5/2014 06:53'!
removeAllBricks

	band subbricks do: [ :each |
		each isBrick ifTrue: [
			each brickRoot: nil.
			each brickOwner: nil ] ].
	
	band subbricks removeAll.
	band removeAllMorphs! !

!GLMGeneralScrollPaneBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 12/5/2014 06:53'!
removeBrick: aBrick
	band removeBrick: aBrick! !

!GLMGeneralScrollPaneBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 12/5/2014 06:53'!
scrollByKeyboard: anEvent
	|velocity|
	
	(self isKeyboardScrollEvent: anEvent) ifFalse: [^ self ].
	velocity := self calculateVelocity: anEvent.
	
	"keycode 30 is Event direction = #up"
	anEvent keyValue = 30 ifTrue: [ self scrollUp: velocity ].
	"keycode 31 is Event direction = #down"
	anEvent keyValue = 31 ifTrue: [ self scrollDown: velocity ].
	
	scrollPosition := band brickBounds top.
	
	self update.
	self changed! !

!GLMGeneralScrollPaneBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 12/5/2014 06:56'!
scrollDown: anInteger

	self subclassResponsibility! !

!GLMGeneralScrollPaneBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/5/2014 06:53'!
scrollPositionBottom

	^ self scrollPositionTop + self brickInnerBounds height! !

!GLMGeneralScrollPaneBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/5/2014 06:53'!
scrollPositionTop

	^ scrollPosition ifNil: [ scrollPosition := 0 ]! !

!GLMGeneralScrollPaneBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 12/5/2014 06:57'!
scrollTo: aBrick

	self subclassResponsibility! !

!GLMGeneralScrollPaneBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 12/5/2014 06:56'!
scrollUp: anInteger

	self subclassResponsibility! !

!GLMGeneralScrollPaneBrick methodsFor: 'initialize' stamp: 'AliakseiSyrel 12/5/2014 06:53'!
unsubscribeListeners

	self activeHand removeEventListener: self! !

!GLMGeneralScrollPaneBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 12/5/2014 06:55'!
update

	self verticalScrollbar update! !

!GLMGeneralScrollPaneBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/5/2014 06:54'!
verticalScrollbar

	^ verticalScrollbar! !

!GLMGeneralScrollPaneBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/5/2014 06:54'!
verticalScrollbar: aBrick

	verticalScrollbar := aBrick.
	verticalScrollbar width: self defaultScrollbarWidth.
	verticalScrollbar layoutProperties floating: self defaultScrollbarPosition.
	verticalScrollbar scrollPane: self.
	super addBrickBack: verticalScrollbar! !

GLMGeneralScrollPaneBrick subclass: #GLMScrollPaneBrick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-UI'!

!GLMScrollPaneBrick commentStamp: 'AliakseiSyrel 11/27/2014 23:32' prior: 0!
A GLMScrollPaneBrick is a very simple scrollpane with support of light scrollbar.
Acceleration mechanism is used for scrolling, so longer user scrolls faster it becomes.

Instance Variables
	band:		<Object>
	currentVelocity:		<Object>
	lastScrollTimeStamp:		<Object>

band
	- xxxxx

currentVelocity
	- xxxxx

lastScrollTimeStamp
	- xxxxx
!

GLMScrollPaneBrick subclass: #GLMScrollListBrick
	instanceVariableNames: 'adapter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-UI'!

!GLMScrollListBrick commentStamp: 'AliakseiSyrel 12/5/2014 06:59' prior: 0!
A GLMScrollListBrick is a list to support of very large amount of items!

!GLMScrollListBrick class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/6/2014 20:05'!
example
	|adaptor|
	adaptor := nil.
	adaptor := GLMBrickListAdaptor new
		sizeLogic: [ 4000000000 ];
		morphAtLogic: [ :index :morph | 
			(morph ifNil: [ GLMLabelBrick new ])
				color: Color random muchLighter;
				text: index asString, ' of ', adaptor count asString;
				textPosition: #center;
				yourself ].

	GLMFoundationBrick new
		brickRoot: (self new adapter: adaptor);
		extent: 300@400;
		openInWindow! !

!GLMScrollListBrick class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/6/2014 20:08'!
exampleCollection

	GLMFoundationBrick new
		brickRoot: (self new adapter: (GLMBrickListAdaptor new on: (GLMUIThemeExtraIcons icons values)));
		extent: 300@400;
		openInWindow! !

!GLMScrollListBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/5/2014 07:20'!
adapter

	^ adapter! !

!GLMScrollListBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/6/2014 12:04'!
adapter: anAdapter

	adapter := anAdapter.
	"self updateVisible"! !

!GLMScrollListBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 12/6/2014 18:25'!
addItemMorph: aMorph after: anotherMorph

	self band addBrickBack: aMorph.
	self setBoundsOf: aMorph after: anotherMorph.
	^ aMorph! !

!GLMScrollListBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 12/6/2014 18:36'!
addItemMorph: aMorph before: anotherMorph

	self band addBrick: aMorph before: anotherMorph.
	self setBoundsOf: aMorph before: anotherMorph.
	^ aMorph! !

!GLMScrollListBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/6/2014 11:00'!
calculateMaxVelocity

	"max velocity must depend from the height of the band"
	^ (self height * 0.9 asInteger) max: self class defaultMaxVelocity! !

!GLMScrollListBrick methodsFor: 'layouting' stamp: 'AliakseiSyrel 12/6/2014 12:07'!
doLayout
	
	self layoutPolicy layoutFloating: self verticalScrollbar in: self withArguments: nil.
	self update.
	self verticalScrollbar update.! !

!GLMScrollListBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/6/2014 10:18'!
gatherInvisibleItems

	self band submorphs isEmpty ifTrue: [ ^ OrderedCollection new ].
			
	^ (OrderedCollection newFrom: (self band submorphs)) select: [ :each | (self isPartiallyVisible: each) not ]! !

!GLMScrollListBrick methodsFor: 'lazy scrolling' stamp: 'AliakseiSyrel 12/6/2014 18:20'!
getAndRemoveInvisibleMorph: aCollection
	|brick|
	brick := self retrieveLast: aCollection.
	^ brick ifNotNil: [ self band removeBrick: brick. brick morph ]! !

!GLMScrollListBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/5/2014 21:39'!
getIndex: aMorph 

	^ aMorph valueOfProperty: #brickScrollListIndex ifAbsent: [ nil ]! !

!GLMScrollListBrick methodsFor: 'lazy scrolling' stamp: 'AliakseiSyrel 12/6/2014 18:57'!
getMorphAt: anInteger recycled: aMorph
	|newMorph|
	
	newMorph := (self adapter morphAt: anInteger convert: aMorph) asBrick.
	self setIndex: anInteger in: newMorph.
	^ newMorph! !

!GLMScrollListBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 12/5/2014 07:22'!
initialize
	super initialize.
	
	self band layoutPolicy: GLMBrickVerticalFillLayout new! !

!GLMScrollListBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 12/6/2014 12:01'!
newBand
	^ super newBand heightBlock: [ :bandBrick |
		bandBrick subbricks isEmpty
		ifTrue: [ 0 ]
		ifFalse: [ bandBrick lastSubbrick brickBounds bottom ] ].! !

!GLMScrollListBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 12/6/2014 11:53'!
newVerticalScrollbar

	^ GLMApproximateScrollbarBrick new! !

!GLMScrollListBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 12/6/2014 19:23'!
preventOverscrolling

	self band subbricks isEmpty ifTrue: [ ^ self ].

	((self getIndex: self band firstSubbrick) = 1) ifTrue: [
		(self band brickBounds origin y > self band firstSubbrick brickBounds top) ifTrue: [
			self band brickBounds: (self band brickBounds translateBy: (0@ self band brickBounds origin y) negated) ] ].
	
	((self getIndex: self band lastSubbrick) = self adapter count) ifTrue: [
		(((self band brickBounds corner y) < self height) and: [ (self isVisible: self band firstSubbrick) not ]) ifTrue: [
			self band brickBounds: (self band brickBounds translateBy: (0@ (self height - self band brickBounds corner y))) ] ].! !

!GLMScrollListBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/5/2014 10:52'!
retrieveLast: aCollection

	^ aCollection isEmpty
		ifTrue: [ nil ]
		ifFalse: [ aCollection removeLast ]! !

!GLMScrollListBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 12/6/2014 18:55'!
scrollDown: anInteger

	((self getIndex: self band lastSubbrick) = self adapter count) ifTrue: [
		(self band brickBounds corner y <= self height) ifTrue: [ ^ self ] ].

	band brickBounds: (band brickBounds translateBy: (0@ anInteger) negated).! !

!GLMScrollListBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 12/6/2014 11:28'!
scrollUp: anInteger

	((self getIndex: self band firstSubbrick) = 1) ifTrue: [
		(self band brickBounds origin y >= self band firstSubbrick brickBounds top) ifTrue: [ ^ self ] ].
	
	self band brickBounds: (self band brickBounds translateBy: (0@ anInteger))! !

!GLMScrollListBrick methodsFor: 'layouting' stamp: 'AliakseiSyrel 12/5/2014 11:05'!
setBoundsOf: aMorph after: afterMorph

	aMorph brickBounds: (afterMorph brickBounds translateBy: (0@aMorph height))! !

!GLMScrollListBrick methodsFor: 'layouting' stamp: 'AliakseiSyrel 12/5/2014 11:05'!
setBoundsOf: aMorph before: beforeMorph

	aMorph brickBounds: (beforeMorph brickBounds translateBy: (0@aMorph height)negated)! !

!GLMScrollListBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/5/2014 10:56'!
setIndex: anInteger in: aMorph 

	aMorph setProperty: #brickScrollListIndex toValue: anInteger! !

!GLMScrollListBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 12/6/2014 11:22'!
update
	super update.
	
	self updateVisible.
	self band width: self width.
	self preventOverscrolling.
	self band doLayout! !

!GLMScrollListBrick methodsFor: 'lazy scrolling' stamp: 'AliakseiSyrel 12/6/2014 18:17'!
updateVisible
	|invisible|
	
	self adapter ifNil: [ ^ self ].
	
	invisible := self gatherInvisibleItems.
	self updateVisibleTop: invisible.
	self updateVisibleBottom: invisible.
	
	invisible do: [ :each | self band removeBrick: each ]
	
	
	
! !

!GLMScrollListBrick methodsFor: 'lazy scrolling' stamp: 'AliakseiSyrel 12/6/2014 19:35'!
updateVisibleBottom: invisibleBricks
	|after|
	
	after := self band lastSubbrick.
	
	[ (self isPartiallyVisible: after) and: [ (self getIndex: after) < self adapter count ] ] whileTrue: [
		after := self
			addItemMorph: (
				self
					getMorphAt: (self getIndex: after) + 1
					recycled: (self getAndRemoveInvisibleMorph: invisibleBricks))
			after: after ]
! !

!GLMScrollListBrick methodsFor: 'lazy scrolling' stamp: 'AliakseiSyrel 12/6/2014 19:35'!
updateVisibleTop: invisibleBricks
	|before|
	
	before := self band subbricks isEmpty
		ifFalse: [ self band firstSubbrick]
		ifTrue: [ self band addBrickBack: (self getMorphAt: 1 recycled: (self getAndRemoveInvisibleMorph: invisibleBricks)) ].
		
	[ (self isPartiallyVisible: before) and: [ (self getIndex: before) > 1 ] ] whileTrue: [
		before := self
			addItemMorph: (
				self
					getMorphAt: (self getIndex: before) - 1
					recycled: (self getAndRemoveInvisibleMorph: invisibleBricks))
			before: before  ]
	! !

!GLMScrollPaneBrick class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 11/27/2014 17:27'!
defaultMaxVelocity
	^ self defaultScrollVelocity * 4! !

!GLMScrollPaneBrick class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/18/2014 01:11'!
defaultScrollAcceleration
	^ 2! !

!GLMScrollPaneBrick class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/18/2014 01:13'!
defaultScrollTimeReset
	^ 350! !

!GLMScrollPaneBrick class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 11/27/2014 17:17'!
defaultScrollTurboTime

	^ 30! !

!GLMScrollPaneBrick class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/18/2014 13:24'!
defaultScrollVelocity
	^ 15! !

!GLMScrollPaneBrick class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/5/2014 07:10'!
example
	|foundation scrollPane|
	
	scrollPane := self new.
	
	foundation := GLMFoundationBrick new.
	foundation brickRoot: scrollPane.
	
	1 to: 20 do: [ :index |
		scrollPane addBrickBack: (GLMBrick new
			color: Color random;
			extent: 200@50).
	].
	
	foundation extent: 200@200.
	
	foundation openInWindow! !

!GLMScrollPaneBrick class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/5/2014 06:41'!
exampleLarge
	|foundation scrollPane|
	
	scrollPane := self new.
	
	foundation := GLMFoundationBrick new.
	foundation brickRoot: scrollPane.
	
	1 to: 10000 do: [ :index |
		scrollPane addBrickBack: (GLMBrick new
			color: Color random;
			extent: 200@50).
	].
	
	foundation extent: 400@300.
	
	foundation openInWindow! !

!GLMScrollPaneBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 12/1/2014 11:59'!
scrollDown: anInteger
	
	band brickBounds corner y <= self height ifTrue: [ ^ self ].
	band brickBounds: (band brickBounds translateBy: (0@ anInteger) negated).
	band brickBounds corner y < self height ifTrue: [ band brickBounds: (band brickBounds translateBy: (0@ (self height - band brickBounds corner y))) ]! !

!GLMScrollPaneBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 11/30/2014 21:29'!
scrollTo: aBrick
	|delta|
	"if already visible no need to scroll"
		
	(self isVisible: aBrick) ifTrue: [ ^ self ].
	
	delta := ((self allowedBounds top - band globalBounds top) - (aBrick globalBounds top - band globalBounds top)).
	delta < 0 ifTrue: [ delta := delta + self allowedBounds height - aBrick height ].
		
	band brickBounds: (band brickBounds translateBy: (0@ delta)).
	band brickBounds corner y < self height
		ifTrue: [ band brickBounds: (band brickBounds translateBy: (0@ (self height - band brickBounds corner y))) ].
		
	(band brickBounds origin y > 0)
		ifTrue: [ band brickBounds: (band brickBounds translateBy: (0@ band brickBounds origin y) negated) ].
	
	scrollPosition := band brickBounds top.
	
	self update.
	self changed.
	
	! !

!GLMScrollPaneBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 11/27/2014 16:58'!
scrollUp: anInteger

	"preventing from scrolling if already at the top"
	band brickBounds origin y >= 0 ifTrue: [ ^ self ].
	"actuall scrolling"
	band brickBounds: (band brickBounds translateBy: (0@ anInteger)).
	"returning scrollpane back if went away"
	band brickBounds origin y > 0 ifTrue: [ band brickBounds: (band brickBounds translateBy: (0@ band brickBounds origin y) negated) ]! !

GLMScrollPaneBrick subclass: #GLMStackedScrollPaneBrick
	instanceVariableNames: 'allowedBounds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-UI'!

!GLMStackedScrollPaneBrick commentStamp: 'AliakseiSyrel 11/27/2014 23:31' prior: 0!
A GLMStackedScrollPaneBrick is a more complicated scrollpane, with scrollbars and stacking mechanism of subbricks that have #stack floating parameter
!

!GLMStackedScrollPaneBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/30/2014 20:47'!
allowedBounds

	^ allowedBounds ifNil: [ allowedBounds := self globalBounds ]! !

!GLMStackedScrollPaneBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/30/2014 20:47'!
allowedBounds: aRectangle

	allowedBounds := aRectangle! !

!GLMStackedScrollPaneBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 11/27/2014 23:29'!
initialize
	super initialize.
	
	self band layoutPolicy: GLMBrickVerticalStackLayout new! !

!GLMStackedScrollPaneBrick methodsFor: 'scrolling' stamp: 'AliakseiSyrel 11/30/2014 20:51'!
update
	super update.
	
	"we need to update band's layout to support stacking"
	self allowedBounds: self band layoutChildren.! !

GLMBrick subclass: #GLMInteractableBrick
	instanceVariableNames: 'normalImage pressedImage selectedImage checkedImage announcer checkedColor normalColor pressedColor selectedColor isSelected isPressed isChecked isEnabled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-UI'!

!GLMInteractableBrick commentStamp: 'AliakseiSyrel 10/17/2014 10:08' prior: 0!
A GLMInteractableBrick is a subclass of GLMBrick to allow user interactions such as: mouseLeave, mouseEnter, mouseDown, mouseUp and for each state can change background color or background image, that resizes accordinately to Brick's size

Instance Variables
	announcer:		<Object>
	checkedColor:		<Object>
	checkedImage:		<Object>
	isChecked:		<Object>
	isEnabled:		<Object>
	isPressed:		<Object>
	isSelected:		<Object>
	normalColor:		<Object>
	normalImage:		<Object>
	pressedColor:		<Object>
	pressedImage:		<Object>
	selectedColor:		<Object>
	selectedImage:		<Object>

announcer
	- xxxxx

checkedColor
	- xxxxx

checkedImage
	- xxxxx

isChecked
	- xxxxx

isEnabled
	- xxxxx

isPressed
	- xxxxx

isSelected
	- xxxxx

normalColor
	- xxxxx

normalImage
	- xxxxx

pressedColor
	- xxxxx

pressedImage
	- xxxxx

selectedColor
	- xxxxx

selectedImage
	- xxxxx
!

GLMInteractableBrick subclass: #GLMActionButtonBrick
	instanceVariableNames: 'action'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-UI'!

!GLMActionButtonBrick commentStamp: 'AliakseiSyrel 10/17/2014 10:08' prior: 0!
A GLMActionButtonBrick is a button for Glamour actions, used in Tabbed presentations

Instance Variables
	action:		<Object>

action
	- xxxxx
!

!GLMActionButtonBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 16:19'!
action: anAction

	action := anAction.
	
	self normalImage: action icon.
	self pressedColor: Color veryVeryLightGray! !

!GLMActionButtonBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 10/16/2014 15:56'!
addUpAction: anActionOrBlock

	anActionOrBlock isBlock
		ifTrue: [ action := anActionOrBlock ]
		ifFalse: [ self action: anActionOrBlock ]! !

!GLMActionButtonBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/16/2014 15:52'!
click: evt

	action isBlock
		ifTrue: [ action value ]
		ifFalse: [ action performOn: self data ].
	
	^ true! !

!GLMActionButtonBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 15:53'!
icon: anImage

	self normalImage: anImage.! !

!GLMActionButtonBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 10/16/2014 16:19'!
initialize
	super initialize.
	
	self enable.! !

!GLMInteractableBrick class methodsFor: 'states' stamp: 'AliakseiSyrel 10/17/2014 10:14'!
normalColorOf: aTrick
	^ self pressedColor: false selectedColor: false of: aTrick! !

!GLMInteractableBrick class methodsFor: 'states' stamp: 'AliakseiSyrel 10/17/2014 10:14'!
normalOf: aTrick
	^ self pressed: false selected: false of: aTrick! !

!GLMInteractableBrick class methodsFor: 'states' stamp: 'AliakseiSyrel 10/17/2014 10:14'!
pressed: isPressed of: aTrick
	^ self pressed: isPressed selected: false of: aTrick! !

!GLMInteractableBrick class methodsFor: 'states' stamp: 'AliakseiSyrel 11/27/2014 12:58'!
pressed: isPressed selected: isSelected checked: isChecked of: aTrick
	"answers sender with image, corresponding specified state"
	
	"pressed has the highest priority"
	(isPressed & aTrick pressedImage notNil)
		ifTrue: [ ^ aTrick pressedImage ].
	
	(isChecked & aTrick checkedImage notNil)
		ifTrue: [ ^ aTrick checkedImage ].
		
	(((isPressed & aTrick pressedImage isNil) | isSelected) & aTrick selectedImage notNil)
		ifTrue: [ ^ aTrick selectedImage ].
	
	^ aTrick normalImage.! !

!GLMInteractableBrick class methodsFor: 'states' stamp: 'AliakseiSyrel 10/17/2014 10:15'!
pressed: isPressed selected: isSelected of: aTrick
	^ self pressed: isPressed selected: isSelected checked: false of: aTrick! !

!GLMInteractableBrick class methodsFor: 'states' stamp: 'AliakseiSyrel 10/17/2014 10:15'!
pressedColor: isPressed of: aTrick
	^ self pressedColor: isPressed selectedColor: false of: aTrick! !

!GLMInteractableBrick class methodsFor: 'states' stamp: 'AliakseiSyrel 11/27/2014 12:59'!
pressedColor: isPressed selectedColor: isSelected checkedColor: isChecked of:aTrick
	"answers sender with image, corresponding specified state"
	
	"pressed has the highest priority"
	(isPressed & aTrick pressedColor notNil)
		ifTrue: [ ^ aTrick pressedColor ].
		
	(isChecked & aTrick checkedColor notNil)
		ifTrue: [ ^ aTrick checkedColor ].
		
	(((isPressed & aTrick pressedColor isNil) | isSelected) & aTrick selectedColor notNil)
		ifTrue: [ ^ aTrick selectedColor ].

	
	^ aTrick normalColor.! !

!GLMInteractableBrick class methodsFor: 'states' stamp: 'AliakseiSyrel 10/17/2014 10:15'!
pressedColor: isPressed selectedColor: isSelected of: aTrick
	^ self pressedColor: isPressed selectedColor: isSelected checkedColor: false of: aTrick! !

!GLMInteractableBrick class methodsFor: 'states' stamp: 'AliakseiSyrel 10/17/2014 10:15'!
selected: isSelected of: aTrick
	^ self pressed: false selected: isSelected of: aTrick! !

!GLMInteractableBrick class methodsFor: 'states' stamp: 'AliakseiSyrel 10/17/2014 10:15'!
selectedColor: isSelected of: aTrick
	^ self pressedColor: false selectedColor: isSelected of: aTrick! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/11/2014 13:43'!
announcer
	^ announcer ifNil: [ announcer := Announcer new ]! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/11/2014 13:48'!
check
	self isChecked ifFalse: [
		isChecked := true.
		self changed.
	]! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:43'!
checkedColor
	^ checkedColor! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:43'!
checkedColor: anObject
	checkedColor := anObject! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:43'!
checkedImage
	^ checkedImage! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:43'!
checkedImage: anObject
	checkedImage := anObject! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/11/2014 13:47'!
click: evt
	^ false! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:43'!
currentColor
	^ self state pressedColor: (self isPressed) selectedColor: (self isSelected) checkedColor: (self isChecked) of: self! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:43'!
currentImage
	^ self state pressed: (self isPressed) selected: (self isSelected) checked: (self isChecked) of: self! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/11/2014 13:48'!
depress
	self isPressed ifTrue: [
		isPressed := false.
		self changed.
		^ true
	].

	^ false! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/16/2014 23:33'!
deselect
	self isSelected ifTrue: [
		isSelected := false.
		self changed.
	]! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/11/2014 13:43'!
disable
	isEnabled := false.! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/11/2014 13:43'!
enable
	
	isEnabled := true.! !

!GLMInteractableBrick methodsFor: 'mouse events' stamp: 'AliakseiSyrel 10/16/2014 23:10'!
handlesMouseDown: evt
	
	^ self isEnabled
		ifTrue: [ true ]
		ifFalse: [ super handlesMouseDown: evt ]
	! !

!GLMInteractableBrick methodsFor: 'mouse events' stamp: 'AliakseiSyrel 10/16/2014 23:00'!
handlesMouseOver: evt
	^ self isEnabled
		ifTrue: [ true ]
		ifFalse: [ super handlesMouseDown: evt ]! !

!GLMInteractableBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 10/17/2014 10:20'!
initialize
	super initialize.
	
	isChecked := false.
	isPressed := false.
	isSelected := false.
	
	self renderer: GLMInteractableBrickRenderer.
	
	self disable.! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/11/2014 13:43'!
isChecked
	^ isChecked.! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/11/2014 13:44'!
isEnabled
	^ isEnabled! !

!GLMInteractableBrick methodsFor: 'testing' stamp: 'AliakseiSyrel 10/11/2014 14:06'!
isFocused

	^ false! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/11/2014 13:44'!
isPressed
	^ isPressed.! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/11/2014 13:44'!
isSelected
	^ isSelected.! !

!GLMInteractableBrick methodsFor: 'mouse events' stamp: 'AliakseiSyrel 10/16/2014 23:06'!
mouseDown: evt
	super mouseDown: evt.
	^ self press.! !

!GLMInteractableBrick methodsFor: 'mouse events' stamp: 'AliakseiSyrel 10/16/2014 23:22'!
mouseEnter: evt
	super mouseEnter: evt.
	^ self select! !

!GLMInteractableBrick methodsFor: 'mouse events' stamp: 'AliakseiSyrel 10/16/2014 23:22'!
mouseLeave: evt
	super mouseLeave: evt.
	^ self deselect! !

!GLMInteractableBrick methodsFor: 'mouse events' stamp: 'AliakseiSyrel 10/23/2014 20:00'!
mouseUp: evt
	super mouseUp: evt.
	(self bounds containsPoint: evt position) & (self isPressed) ifTrue: [
		self depress.
		^ self click: evt
	] ifFalse: [
		self deselect.
		^ self depress.
	]! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:44'!
normalColor
	^ normalColor! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:44'!
normalColor: anObject
	normalColor := anObject! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:44'!
normalImage
	^ normalImage! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:44'!
normalImage: anObject
	normalImage := anObject! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/11/2014 13:48'!
press
	self isPressed ifFalse: [
		isPressed := true.
		self changed.
	].

	^ false! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:44'!
pressedColor
	^ pressedColor! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:44'!
pressedColor: anObject
	pressedColor := anObject! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:44'!
pressedImage
	^ pressedImage! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:45'!
pressedImage: anObject
	pressedImage := anObject! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/16/2014 23:33'!
select
	self isSelected ifFalse: [ 
		isSelected := true.
		self changed.
	]! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:44'!
selectedColor
	^ selectedColor! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:45'!
selectedColor: anObject
	selectedColor := anObject! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:45'!
selectedImage
	^ selectedImage! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 13:45'!
selectedImage: anObject
	selectedImage := anObject! !

!GLMInteractableBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/17/2014 10:15'!
state

	^ self class! !

!GLMInteractableBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/11/2014 13:48'!
uncheck
	self isChecked ifTrue: [
		isChecked := false.
		self changed.
	]! !

GLMInteractableBrick subclass: #GLMLabelBrick
	instanceVariableNames: 'isDotsAdded dotsBrick stringBrick'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-UI'!

!GLMLabelBrick commentStamp: 'AliakseiSyrel 10/18/2014 14:18' prior: 0!
A GLMLabelBrick is standard label Brick, that can shrink text if it's size becomes smaller then actual text size.

Text shrinking works out of box, you don't need to do anything

Instance Variables
	dotsBrick		<GLMStringBrick>
	isDotsAdded:		<boolean>
	stringBrick rick		<GLMStringBrick>

dotsBrick
	- represents a Brick that is added at the end of the text when Brick's size becomes smaller than actual text size

isDotsAdded
	- true if dotsBrick is currently added visible, false otherwise

stringBrick
	- represents actual label text Brick
!

!GLMLabelBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 12/2/2014 17:28'!
approximateWidth

		^ self label approximateWidth + self layoutProperties horizontalMargin + self layoutProperties horizontalPadding! !

!GLMLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/6/2014 17:26'!
contents: aStringOrText

	self text: aStringOrText asString! !

!GLMLabelBrick methodsFor: 'default values' stamp: 'AliakseiSyrel 10/16/2014 14:33'!
defaultDotsText
	^ '...'! !

!GLMLabelBrick methodsFor: 'default values' stamp: 'AliakseiSyrel 10/16/2014 14:03'!
defaultInsetBeforeDots
	^ 1! !

!GLMLabelBrick methodsFor: 'layouting' stamp: 'AliakseiSyrel 10/17/2014 10:45'!
doLayout
	"contolls logic of text schrinking"
	|isFit|
	
	super doLayout.
	
	"checking if label text fits in me"
	isFit := self label isFitsInParent.
	
	(isFit & (self isDotsAdded not)) ifTrue: [ ^ self ].
	(isFit not & self isDotsAdded) ifTrue: [ ^ self ].
	
	(isFit & self isDotsAdded) ifTrue: [
		self removeBrick: self dotsBrick.
		isDotsAdded := false.
		super doLayout.
	] ifFalse: [ 
		self addBrickBack: self dotsBrick.
		isDotsAdded := true.
		super doLayout.
	]
	! !

!GLMLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/17/2014 10:00'!
dotsBrick

	^ dotsBrick! !

!GLMLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/18/2014 14:50'!
fontSize: anInteger

	self label fontSize: anInteger.
	self dotsBrick fontSize: anInteger.! !

!GLMLabelBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 11/22/2014 16:46'!
initialize
	super initialize.
	
	stringBrick := self newStringBrick.
	stringBrick layoutProperties horizontalPercent: 100.
	stringBrick layoutProperties marginRight: self defaultInsetBeforeDots.
	self addBrickBack: stringBrick.
	
	"creating dots morph, that will be displayed when text is being clipped"
	dotsBrick := GLMStringBrick new.
	dotsBrick layoutProperties horizontalPercent: 0.
	dotsBrick text: self defaultDotsText.
	dotsBrick layoutProperties minWidth: (dotsBrick textSize x).
	
	isDotsAdded := false.
	! !

!GLMLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 14:05'!
isDotsAdded
	^ isDotsAdded! !

!GLMLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/17/2014 10:00'!
label
	^ stringBrick! !

!GLMLabelBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 10/17/2014 09:59'!
newStringBrick
	^ GLMStringBrick new! !

!GLMLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 14:09'!
text
	^ self label text! !

!GLMLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/5/2014 16:44'!
text: aString

	self label text: aString! !

!GLMLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/18/2014 13:29'!
textColor: aColor

	self label textColor: aColor.
	self dotsBrick textColor: aColor! !

!GLMLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/18/2014 13:21'!
textPosition: aSymbol

	self label textPosition: aSymbol.
	self dotsBrick textPosition: aSymbol.! !

!GLMLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/18/2014 14:42'!
weightValue: anInteger

	self label weightValue: anInteger.
	self dotsBrick weightValue: anInteger.! !

GLMInteractableBrick subclass: #GLMStringBrick
	instanceVariableNames: 'font familyName fontSize textSize text textColor textPosition highlightedString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-UI'!

!GLMStringBrick commentStamp: 'AliakseiSyrel 10/17/2014 10:06' prior: 0!
A GLMStringBrick is low level String Brick. Text can't be drawn outside of Brick's bounds, which makes it very usefull for smart text shrinking.

Instance Variables
	familyName:		<Object>
	font:		<Object>
	fontSize:		<Object>
	text:		<Object>
	textColor:		<Object>
	textPosition:		<Object>
	textSize:		<Object>

familyName
	- xxxxx

font
	- xxxxx

fontSize
	- xxxxx

text
	- xxxxx

textColor
	- xxxxx

textPosition
	- xxxxx

textSize
	- xxxxx
!

!GLMStringBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 12/2/2014 17:28'!
approximateWidth

	^ self textSize x + self layoutProperties horizontalMargin + self layoutProperties horizontalPadding! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/4/2014 11:21'!
calculateHighlightingBounds
	|textBounds highlightBounds last|
	
	highlightBounds := OrderedCollection new.
	
	textBounds := (self calculateTextPosition extent: self textSize) translateBy: (0@0)negated.
	
	last := self text asLowercase findString: self highlightedText asLowercase startingAt: 1.
	last = 0 ifTrue: [^ highlightBounds].
	[last > 0] whileTrue: [ |beforeHighlightTextSize highlightSize matchingString|		
		matchingString := self text copyFrom: last to: last + self highlightedText size - 1.
		highlightSize := self sizeOf: matchingString.
		beforeHighlightTextSize := self sizeOf: (self text first: (last - 1)).
		highlightBounds add: ((textBounds translateBy: ((beforeHighlightTextSize x)@0)) withWidth: highlightSize x).
		last := self text asLowercase findString: self highlightedText asLowercase startingAt: last + 1 ].
	
	^ highlightBounds! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/18/2014 23:47'!
calculateTextPosition

	self textPosition = #leftCenter ifTrue: [ 
		^ (self brickBounds origin + self textPositionVerticalCenter) floor
	].

	self textPosition = #center ifTrue: [ 
		^ (self brickBounds origin + self textPositionVerticalCenter + self textPositionHorizontalCenter)floor
	].

	self textPosition = #leftTop ifTrue: [
		^ self brickBounds origin
	].

	self textPosition = #rightCenter ifTrue: [
		^ ((self brickBounds topRight + self textPositionVerticalCenter - (self textSize x@0)) max: self brickBounds origin) floor
	].

	^ self brickBounds origin! !

!GLMStringBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 10/16/2014 15:19'!
defaultColor
	^ Color black! !

!GLMStringBrick methodsFor: 'defaults' stamp: 'AliakseiSyrel 10/16/2014 15:14'!
defaultFamilyName
	^ self theme labelFont familyName! !

!GLMStringBrick methodsFor: 'defaults' stamp: 'AliakseiSyrel 10/17/2014 10:31'!
defaultSize
	^ self theme labelFont pointSize! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 15:14'!
familyName
	^ familyName! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 05:04'!
familyName: aString
	familyName := aString.
	self updateFont.! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 05:06'!
font

	^ font! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/18/2014 16:34'!
font: aFont

	font := aFont.
	
	aFont ifNil: [ self updateFont ].
	
	familyName := font familyName.
	fontSize := font pointSize.! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 05:04'!
fontSize
	^ fontSize! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 05:05'!
fontSize: aNumber
	fontSize := aNumber.
	self updateFont.! !

!GLMStringBrick methodsFor: 'public' stamp: 'AliakseiSyrel 12/4/2014 10:39'!
highlight: aString

	highlightedString := aString! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/4/2014 10:34'!
highlightedText
	
	^ highlightedString ifNil: [ highlightedString := '' ]! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/4/2014 11:18'!
highlightingLogic
	"[ :aCanvas :aRectangle ]"
	
	^ self valueOfProperty: #brickHighlightingLogic ifAbsentPut: [ nil ] ! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/4/2014 11:17'!
highlightingLogic: aBlockWithTwoParameters
	"[ :aCanvas :aRectangle ]"
	
	self setProperty: #brickHighlightingLogic toValue: aBlockWithTwoParameters! !

!GLMStringBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 10/18/2014 16:34'!
initialize
	super initialize.
	
	fontSize := self defaultSize.
	familyName := self defaultFamilyName.
	textColor := self defaultColor.
	text := ''.
	
	textPosition := #leftCenter.
	
	self updateFont.
	! !

!GLMStringBrick methodsFor: 'testing' stamp: 'AliakseiSyrel 10/17/2014 09:56'!
isFitsInParent

	^ self brickOwner
		ifNil: [ self brickBounds containsRect: (self brickOuterBounds origin extent: self textSize) ]
		ifNotNil: [
			self brickOwner brickBounds extent >= self textSize ]
				! !

!GLMStringBrick methodsFor: 'drawing' stamp: 'AliakseiSyrel 12/4/2014 11:17'!
onDraw: aCanvas

	super onDraw: aCanvas.
	
	self calculateHighlightingBounds do: [ :each |
		self highlightingLogic
			ifNil: [ aCanvas line: each bottomLeft to: each bottomRight width: 1 color: self textColor ]
			ifNotNil: [ self highlightingLogic cull: aCanvas cull: each ] ].
	
	aCanvas
		drawString: self text
		at: self calculateTextPosition
		font: self font
		color: self textColor.! !

!GLMStringBrick methodsFor: 'private' stamp: 'AliakseiSyrel 10/5/2014 16:50'!
privateSetText: aString

	text := aString.
	textSize := nil.! !

!GLMStringBrick methodsFor: 'public' stamp: 'AliakseiSyrel 10/4/2014 05:07'!
sizeOf: aString

	^ (self font widthOfString: aString) @ self font height! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 05:12'!
text

	^ text! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/6/2014 17:26'!
text: aString
	|repaint|
	
	repaint := text size > 0.	
	self privateSetText: aString.

	repaint ifTrue: [ self brickOwner doLayout. self root changed ]! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 00:35'!
textColor
	^ textColor! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 00:36'!
textColor: aColor
	textColor := aColor.
	self updateFont.! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/11/2014 01:13'!
textPosition

	^ textPosition! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/18/2014 13:19'!
textPosition: aSymbol
	"supported:
	#leftCenter
	#center
	#leftTop
	"
	textPosition := aSymbol.! !

!GLMStringBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 10/17/2014 09:56'!
textPositionHorizontalCenter

	^ ((((self brickBounds width - self textSize x) max: 0) /2)@0)! !

!GLMStringBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 10/25/2014 10:28'!
textPositionVerticalCenter

	^ (0@(self brickBounds height / 2)) - (0@(self fontSize/2)) - (0@3)! !

!GLMStringBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 05:13'!
textSize

	^ textSize ifNil: [ textSize := self sizeOf: self text ]! !

!GLMStringBrick methodsFor: 'private' stamp: 'AliakseiSyrel 10/18/2014 16:33'!
updateFont
	font := LogicalFont familyName: self familyName pointSize: self fontSize.! !

GLMInteractableBrick subclass: #GLMTabLabelBrick
	instanceVariableNames: 'tabSelector normalLabel selectedLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-UI'!

!GLMTabLabelBrick commentStamp: 'AliakseiSyrel 10/17/2014 10:06' prior: 0!
A GLMTabLabelTurboBrick is  single resizable Tab Label used in LazyTabGroupMorph.

Instance Variables
	normalLabel:		<Object>
	selectedLabel:		<Object>
	tabSelector:		<Object>

normalLabel
	- xxxxx

selectedLabel
	- xxxxx

tabSelector
	- xxxxx
!

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:24'!
adoptPaneColor: paneColor
	"Use the theme for fillStyle and border."
	
	super adoptPaneColor: paneColor.
	paneColor ifNil: [^self].
	self fillStyle: self fillStyleToUse.
	self borderStyle: self borderStyleToUse! !

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:24'!
borderStyleToUse
	"Answer the borderStyle that should be used for the receiver."
	
	^self isSelected
		ifTrue: [self theme tabLabelSelectedBorderStyleFor: self]
		ifFalse: [self theme tabLabelNormalBorderStyleFor: self]! !

!GLMTabLabelBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 10/17/2014 09:57'!
deselect
	self layoutProperties minWidth: 0.
	self brickRoot changed.
	self brickRoot doLayout.
	self brickRoot changed.! !

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:24'!
fillStyleToUse
	"Answer the basic fill style for the receiver."

	^self isSelected
		ifTrue: [self selectedFillStyle] 
		ifFalse: [self normalFillStyle]! !

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:24'!
font: aFont
	"Set the label font"

	self normalLabel allMorphsDo: [:m |
		(m respondsTo: #font:) ifTrue: [m font: aFont]].
	self selectedLabel allMorphsDo: [:m |
		(m respondsTo: #font:) ifTrue: [m font: aFont]]! !

!GLMTabLabelBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 10/16/2014 23:26'!
initialize
	"Initialize the receiver."
	
	super initialize.
	self fillStyle: self fillStyleToUse.
	self borderStyle: self borderStyleToUse.
	
	self enable.! !

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:24'!
isSelected
	"Answer whether the tab is selected."

	^self tabSelector
		ifNil: [false]
		ifNotNil: [:selector | selector selectedTab == self]! !

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:24'!
label
	"Answer the label contents."

	^self isSelected
		ifTrue: [self selectedLabel userString ifNil: [self firstSubmorph]]
		ifFalse: [self normalLabel userString ifNil: [self firstSubmorph]]! !

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 16:42'!
label: aTrickMorph
	"Change the label contents"
	
	aTrickMorph layoutProperties horizontalPercent: 100.
	self layoutProperties maxWidthBlock: aTrickMorph layoutProperties maxWidthBlock.

	self
		normalLabel: aTrickMorph;
		selectedLabel: aTrickMorph;
		selected: self isSelected! !

!GLMTabLabelBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/16/2014 11:01'!
label: aTrickMorph selected: selectedTrickMorph
	"Change the label contents"

	aTrickMorph layoutProperties horizontalPercent: 100.
	selectedTrickMorph layoutProperties horizontalPercent: 100.
	
	self layoutProperties maxWidthBlock: aTrickMorph layoutProperties maxWidthBlock.
	
	self
		normalLabel: aTrickMorph;
		selectedLabel: selectedTrickMorph;
		selected: self isSelected! !

!GLMTabLabelBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/2/2014 17:13'!
normalFillStyle
	"Return the normal fillStyle of the receiver."
	
	^ self theme tabLabelNormalFillStyleFor: self! !

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:24'!
normalLabel

	^ normalLabel! !

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:24'!
normalLabel: anObject

	normalLabel := anObject! !

!GLMTabLabelBrick methodsFor: 'actions' stamp: 'AliakseiSyrel 11/22/2014 17:07'!
select
	self layoutProperties minWidthBlock: [ (self label layoutProperties maxWidthBlock value: self label) min: self brickRoot width ].
	self brickRoot doLayout.
	self brickRoot changed.! !

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/17/2014 09:57'!
selected: aBoolean
	"Use the appropriate label."

	self removeAllBricks.
	self isSelected
		ifTrue: [self addBrickBack: self selectedLabel]
		ifFalse: [self addBrickBack: self normalLabel]! !

!GLMTabLabelBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/2/2014 17:13'!
selectedFillStyle
	"Return the selected fillStyle of the receiver."
	
	^ self theme tabLabelSelectedFillStyleFor: self! !

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:24'!
selectedLabel

	^ selectedLabel! !

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:24'!
selectedLabel: anObject

	selectedLabel := anObject! !

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:24'!
tabSelector

	^ tabSelector! !

!GLMTabLabelBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:24'!
tabSelector: anObject

	tabSelector := anObject! !

GLMBrick subclass: #GLMScrollbarBrick
	instanceVariableNames: 'scrollPane bar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-UI'!

!GLMScrollbarBrick commentStamp: 'AliakseiSyrel 11/19/2014 20:32' prior: 0!
A GLMScrollbarBrick is vertical scollbar for a scrollpane. User can't interact with it

Instance Variables
	bar:		<Object>
	scrollPane:		<Object>

bar
	- xxxxx

scrollPane
	- xxxxx
!

GLMScrollbarBrick subclass: #GLMApproximateScrollbarBrick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-UI'!

!GLMApproximateScrollbarBrick commentStamp: 'AliakseiSyrel 12/6/2014 11:58' prior: 0!
A GLMApproximateScrollbarBrick can be used only with GLMScrollListBrick or with other lists that uses adapters.

Approximates the height of band depending on average height of all visible items.
!

!GLMApproximateScrollbarBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/6/2014 19:12'!
approximateBandHeight
	|visible averageItemHeight|
	
	visible := self scrollPane band submorphs select: [ :each | self scrollPane isPartiallyVisible: each ].
	visible isEmpty ifTrue: [ ^ 0 ].
	
	averageItemHeight := (visible inject: 0 into: [ :visibleHeight :each | visibleHeight + each height ]) / visible size.
	^ self scrollPane adapter count * averageItemHeight.! !

!GLMApproximateScrollbarBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/6/2014 19:08'!
calculateScrollbarHeight
	|bandHeight|
	bandHeight := self approximateBandHeight.
	bandHeight = 0 ifTrue: [ ^ 0 ].
	
	^ (self scrollPane height / bandHeight * self height) ceiling.
	! !

!GLMApproximateScrollbarBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/6/2014 19:10'!
calculateScrollbarTopOffset
	|bandHeight|
	bandHeight := self approximateBandHeight.
	bandHeight = 0 ifTrue: [ ^ 0 ].
	
	^ (self height / bandHeight * self scrollPane band brickBounds top abs) floor.! !

!GLMScrollbarBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 11/19/2014 20:11'!
bar

	^ bar! !

!GLMScrollbarBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 11/19/2014 20:28'!
bar: aBrick

	bar := aBrick.
	bar color: Color veryLightGray.
	self addBrickBack: aBrick! !

!GLMScrollbarBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/6/2014 11:44'!
calculateScrollbarHeight

	^ (((self scrollPane height) / (self scrollPane band height)) * self height) ceiling.! !

!GLMScrollbarBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/6/2014 11:45'!
calculateScrollbarTopOffset

	^ (((self height) / (self scrollPane band height)) * (self scrollPane band brickBounds top abs)) floor.! !

!GLMScrollbarBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 11/19/2014 20:27'!
initialize
	super initialize.
	
	self layoutPolicy: GLMBrickNoLayout new.
	self bar: self newBar! !

!GLMScrollbarBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 11/19/2014 20:16'!
newBar

	^ GLMBrick new! !

!GLMScrollbarBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/19/2014 20:08'!
scrollPane
	^ scrollPane! !

!GLMScrollbarBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/19/2014 20:18'!
scrollPane: anObject
	scrollPane := anObject.
	self update.! !

!GLMScrollbarBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/6/2014 11:45'!
update
	|height top width|
	
	self scrollPane band height = 0 ifTrue: [
		bar brickBounds: ((0@0) extent: 0@0).
		^ self changed.
	].
	
	height := self calculateScrollbarHeight.
	top := self calculateScrollbarTopOffset.
	
	width := (height >= self height)
		ifTrue: [ 0 ]
		ifFalse: [ self width ].
	
	bar brickBounds: ((0@top) extent: width@height).
	
	self changed! !

Morph subclass: #GLMFoundationBrick
	instanceVariableNames: 'brickRoot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Widgets'!

!GLMFoundationBrick commentStamp: 'AliakseiSyrel 10/17/2014 10:32' prior: 0!
A GLMFoundationBrick is connection layer between brick widgets and morphic.

See GLMBrick class comment for more info.

Instance Variables
	brickRoot:		<Object>

brickRoot
	- xxxxx
!

!GLMFoundationBrick class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/2/2014 19:02'!
exampleLarge
	|foundation scrollPane|
	
	scrollPane := GLMScrollPaneBrick new.
	
	foundation := self new.
	foundation brickRoot: scrollPane.
	
	1 to: 10000 do: [ :index |
		scrollPane addBrickBack: (GLMBrick new
			color: Color random;
			extent: 200@50).
	].
	
	foundation extent: 400@300.
	
	foundation openInWindow! !

!GLMFoundationBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 10/17/2014 09:48'!
addAllBricks: aCollection

	aCollection do: [ :each | self addBrickBack: each ]! !

!GLMFoundationBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 10/17/2014 10:17'!
addBrickBack: aBrick

	self brickRoot addBrickBack: aBrick.! !

!GLMFoundationBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/17/2014 10:21'!
brickRoot

	^ brickRoot! !

!GLMFoundationBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/17/2014 10:22'!
brickRoot: aBrick

	self brickRoot ifNotNil: [
		self brickRoot brickOwner: nil.
		self brickRoot brickRoot: nil.
		self removeMorph: self brickRoot.
		brickRoot := nil.
	].
	
	brickRoot := aBrick.
	brickRoot brickOwner: self.
	brickRoot brickRoot: self.
	self addMorphBack: brickRoot.
	
	! !

!GLMFoundationBrick methodsFor: 'layouting' stamp: 'AliakseiSyrel 10/17/2014 09:57'!
doLayout

	self brickRoot doLayout.! !

!GLMFoundationBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 11/20/2014 12:23'!
extent: aPoint
	|left top right bottom|
	
	super extent: aPoint.
	
	left := self brickRoot layoutProperties marginLeft.
	top := self brickRoot layoutProperties marginTop.
	
	right := self extent x - self brickRoot layoutProperties marginRight.
	bottom := self extent y - self brickRoot layoutProperties marginBottom.
	
	self brickRoot brickBounds: (left@top corner: (right@bottom)).
	
	self brickRoot doLayout.! !

!GLMFoundationBrick methodsFor: 'drawing' stamp: 'AliakseiSyrel 10/17/2014 23:47'!
fullDrawOn: aCanvas
	"preventing from drawing outside of me"
	super fullDrawOn: (aCanvas copyClipRect: self fullBounds).! !

!GLMFoundationBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 12/2/2014 18:55'!
globalBounds

	^ self bounds! !

!GLMFoundationBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 12/2/2014 18:48'!
globalBoundsTranslateFactor

	^ self globalBounds origin! !

!GLMFoundationBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 10/17/2014 10:12'!
initialize
	super initialize.
	
	self beTransparent.
	
	self brickRoot: GLMBrick new.
	self brickRoot layoutPolicy: GLMBrickHorizontalFillProportionalLinearLayout new.! !

!GLMFoundationBrick methodsFor: 'testing' stamp: 'AliakseiSyrel 10/11/2014 15:38'!
isFocused

	^ false! !

!GLMFoundationBrick methodsFor: 'private' stamp: 'AliakseiSyrel 10/24/2014 13:04'!
privateExtent: aPoint

	super extent: aPoint.! !

!GLMFoundationBrick methodsFor: 'geometry' stamp: 'AliakseiSyrel 10/5/2014 13:51'!
relativeBounds

	^ 0@0 extent: self extent! !

!GLMFoundationBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 10/17/2014 09:57'!
removeAllBricks

	self brickRoot removeAllBricks! !

GLMFoundationBrick subclass: #GLMProfileableFoundationBrick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Widgets'!

!GLMProfileableFoundationBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/2/2014 18:37'!
fullDrawOn: aCanvas
	"preventing from drawing outside of me"
	[ super fullDrawOn: (aCanvas) ] timeProfile! !

GLMFoundationBrick subclass: #GLMTabSelectorBrick
	instanceVariableNames: 'selectedIndex visibleTabRange font tabs controls wrapScrolling'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Widgets'!

!GLMTabSelectorBrick commentStamp: 'AliakseiSyrel 10/17/2014 10:33' prior: 0!
A GLMTabSelectorBrick is a simplified TabSelectorMorph with support of smart tab resizing.
New implementation doesn't have any scrollbars or scroll arrows.

Instance Variables
	controls:		<Object>
	font:		<Object>
	selectedIndex:		<Object>
	tabs:		<Object>
	visibleTabRange:		<Object>
	wrapScrolling:		<Object>

controls
	- xxxxx

font
	- xxxxx

selectedIndex
	- xxxxx

tabs
	- xxxxx

visibleTabRange
	- xxxxx

wrapScrolling
	- xxxxx
!

!GLMTabSelectorBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
addTab: aStringOrMorph
	"Add a new tab with the given text."
	
	self tabs add: (self newLabelMorph: aStringOrMorph).
	self updateTabs! !

!GLMTabSelectorBrick methodsFor: 'adding' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
addTab: aStringOrMorph selected: selectedStringOrMorph
	"Add a new tab with the given text or morph and alternate for when selected."
	
	self tabs add: (self newLabelMorph: aStringOrMorph selected: selectedStringOrMorph).
	self updateTabs! !

!GLMTabSelectorBrick methodsFor: 'rounding' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
cornerStyle: aSymbol
	"Pass to tabs also."

	super cornerStyle: aSymbol.
	self tabs do: [:t | t cornerStyle: aSymbol]! !

!GLMTabSelectorBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
font
	"Answer the label font"

	^font! !

!GLMTabSelectorBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
font: aFont
	"Set the label font"

	font == aFont ifTrue: [^self].
	font := aFont.
	self updateFont! !

!GLMTabSelectorBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
handlesKeyboard: evt
	"Yes, we do it here."
	
	^true! !

!GLMTabSelectorBrick methodsFor: 'initialization' stamp: 'AliakseiSyrel 10/16/2014 10:40'!
initialize
	"Initialize the receiver."

	super initialize.
	selectedIndex := 0.
	self
		tabs: OrderedCollection new;
		roundedCorners: #(1 4);
		borderWidth: 0.! !

!GLMTabSelectorBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
keyStroke: event 
	"Process keys navigation and space to toggle."

	(self navigationKey: event) ifTrue: [^self].
	event keyCharacter = Character arrowLeft
		ifTrue: [self selectPreviousTab].
	event keyCharacter = Character arrowRight
		ifTrue: [self selectNextTab]! !

!GLMTabSelectorBrick methodsFor: 'event handling' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
keyboardFocusChange: aBoolean
	"The message is sent to a morph when its keyboard focus changes.
	Update for focus feedback."
	super keyboardFocusChange: aBoolean.
	self focusChanged! !

!GLMTabSelectorBrick methodsFor: 'layout' stamp: 'AliakseiSyrel 10/16/2014 17:31'!
minHeight
	^ self theme buttonMinHeight! !

!GLMTabSelectorBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 10/17/2014 09:45'!
newLabelMorph: aStringOrMorph
	"Answer a new label morph with the given label text."

	^GLMTabLabelBrick new
		roundedCorners: #(1 4);
		cornerStyle: self cornerStyle;
		label: aStringOrMorph;
		font: self font;
		on: #mouseDown send: #tabClicked:with: to: self;
		tabSelector: self! !

!GLMTabSelectorBrick methodsFor: 'instance creation' stamp: 'AliakseiSyrel 10/17/2014 09:45'!
newLabelMorph: aStringOrMorph selected: selectedStringOrMorph
	"Answer a new label morph with the given label text or morph and
	alternate when selected."

	^GLMTabLabelBrick new
		roundedCorners: #(1 4);
		cornerStyle: self cornerStyle;
		label: aStringOrMorph selected: selectedStringOrMorph;
		font: self font;
		on: #mouseDown send: #tabClicked:with: to: self;
		tabSelector: self! !

!GLMTabSelectorBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/16/2014 09:39'!
relabelTab: aTab with: aStringOrMorph
	"Relabel the tab update tab layout."

	aTab label: aStringOrMorph.
	aTab owner ifNotNil: [
		self updateTabs ]! !

!GLMTabSelectorBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
removeTabIndex: anInteger
	"Remove the tab at the given index and
	adjust any selected (next or first if was last)."
	
	self tabs removeAt: anInteger.
	self selectedIndex: 0.
	self tabs ifNotEmpty: [
		self selectedIndex: self selectedIndex - 1 \\ self tabs size + 1]
		! !

!GLMTabSelectorBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
selectNextTab
	"Select the next tab, or the first if none selected."
	
	self selectedIndex: self selectedIndex \\ self tabs size + 1! !

!GLMTabSelectorBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
selectPreviousTab
	"Select the previous tab, or the last if none selected."
	
	self selectedIndex: (self selectedIndex < 2
		ifTrue: [self tabs size]
		ifFalse: [self selectedIndex - 1])! !

!GLMTabSelectorBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
selectedIndex
	"Answer the value of selectedIndex"

	^ selectedIndex! !

!GLMTabSelectorBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:41'!
selectedIndex: index
	"Set the value of selectedIndex"

	|oldIndex|
	selectedIndex == index ifTrue: [^self].
	oldIndex := selectedIndex.
	selectedIndex := (index min: self tabs size).
	self updateTabs.
	self changed: #selectedIndex with: oldIndex! !

!GLMTabSelectorBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
selectedTab
	"Answer the selected tab."
	
	^self selectedIndex = 0
		ifFalse: [self tabs at: self selectedIndex ifAbsent: [nil]]! !

!GLMTabSelectorBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
tabClicked: evt with: aMorph 
	"A tab has been clicked."
	
	self selectedIndex: (self tabs indexOf: aMorph)! !

!GLMTabSelectorBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
tabs

	^ tabs! !

!GLMTabSelectorBrick methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
tabs: anObject

	tabs := anObject! !

!GLMTabSelectorBrick methodsFor: 'private' stamp: 'AliakseiSyrel 10/16/2014 09:20'!
updateFont
	"Update the label font."

	self tabs do: [:t | t font: self font].
	self updateTabs! !

!GLMTabSelectorBrick methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 10/17/2014 09:57'!
updateTabs
	"Update the submorphs based on visible tabs."

	|selectedTab|
	self removeAllBricks.
	self tabs ifEmpty: [^self].
	selectedTab := self selectedTab.
	self tabs do: [:t |
		t selected: (t == selectedTab).
		t layoutProperties horizontalPercent: 100 / self tabs size ].
	self
		addAllBricks: self tabs;
		adoptPaneColor.
	
	self doLayout.! !

!Morph methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 12/6/2014 17:17'!
asBrick
	
	^ self owner
		ifNil: [ GLMMorphBrick on: self ]
		ifNotNil: [ self owner isBrick
			ifTrue: [ self owner ]
			ifFalse: [ GLMMorphBrick on: self ] ]! !

!Morph methodsFor: '*Glamour-Morphic-Brick' stamp: 'TudorGirba 12/5/2014 06:41'!
exportAsPNGSilently
	| fName time |
	time := (DateAndTime now asString copyReplaceAll: ':' with: '-') copyReplaceAll: '.' with: '-'.
	fName := self externalName, time , '.png'.
	PNGReadWriter putForm: self imageForm onFileNamed: fName! !

!Morph methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 10/17/2014 15:28'!
isBrick

	^ false! !

!Morph methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 11/27/2014 17:58'!
privateBrickDoubleLink

	^ self valueOfProperty: #brickDoubleLink ifAbsentPut: [ nil ]! !

!Morph methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 11/27/2014 17:58'!
privateBrickDoubleLink: aDoubleLink

	self setProperty: #brickDoubleLink toValue: aDoubleLink! !

LayoutPolicy subclass: #GLMBrickLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Layouts'!

!GLMBrickLayout commentStamp: 'AliakseiSyrel 10/17/2014 10:12' prior: 0!
A GLMBrickLayout is low level layout class providing api for positioning bricks with specific order
!

GLMBrickLayout subclass: #GLMBrickHorizontalLinearLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Layouts'!

!GLMBrickHorizontalLinearLayout commentStamp: 'AliakseiSyrel 10/17/2014 10:37' prior: 0!
A GLMBrickHorizontalLinearLayout is Linear layout, where all Bricks are being positioned horizintally in one line. The size of Bricks depends only from each Brick's extent. If any Bricks goes outside of the parent with this layout, outside part will not be drawn.
!

GLMBrickHorizontalLinearLayout subclass: #GLMBrickHorizontalFillLinearLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Layouts'!

!GLMBrickHorizontalFillLinearLayout commentStamp: 'AliakseiSyrel 11/20/2014 13:59' prior: 0!
A GLMBrickHorizontalFillLinearLayout is Linear layout, where all Bricks are being positioned horizontally in one line. The size of Bricks depends only from each Brick's extent. If any Bricks goes outside of the parent with this layout, outside part will not be drawn. The height of all elements in this layout is the same!

!GLMBrickHorizontalFillLinearLayout methodsFor: 'layouting' stamp: 'AliakseiSyrel 11/22/2014 16:25'!
extentOf: aBrick in: owner withArguments: aHashTable
	
	^ (self originalWidthOf: aBrick)@(owner brickInnerBounds height - aBrick layoutProperties verticalMargin)! !

!GLMBrickHorizontalLinearLayout methodsFor: 'layouting' stamp: 'AliakseiSyrel 12/6/2014 16:53'!
layout: aBrick in: newBounds
	|arguments|
	
	arguments := self prepareArgumentsFor: aBrick.
	
	aBrick subbricks
		inject: 0
		into: [ :leftOffset :each |
			self prepareLayout: each.
			(self supportsFloating: each layoutProperties floating) ifFalse: [
				|layoutBounds|
			
				layoutBounds := GLMBrickLayoutBounds on: (self boundsOf: each in: aBrick withArguments: arguments) of: each.
				layoutBounds translateBy: (leftOffset@0).
				layoutBounds moveOuterToOrigin.
			
				self setNewBounds: layoutBounds to: each in: aBrick.
			
				leftOffset + layoutBounds outerBounds width ]
			ifTrue: [ leftOffset  + ( self layoutFloating: each in: newBounds withArguments: arguments) ] ]

	! !

!GLMBrickHorizontalLinearLayout methodsFor: 'bounds' stamp: 'AliakseiSyrel 12/1/2014 17:45'!
translate: aBrick by: anInteger

	aBrick brickBounds: (aBrick brickBounds translateBy: anInteger@0)! !

GLMBrickHorizontalLinearLayout subclass: #GLMBrickHorizontalProportionalLinearLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Layouts'!

!GLMBrickHorizontalProportionalLinearLayout commentStamp: 'AliakseiSyrel 10/17/2014 10:37' prior: 0!
A GLMBrickHorizontalProportionalLinearLayout is an improvement of standard LinearLayout such that element are positioned proportionaly in the parent based on Brick>>layoutProperties horizontalPercent.
!

GLMBrickHorizontalProportionalLinearLayout subclass: #GLMBrickHorizontalFillProportionalLinearLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Layouts'!

!GLMBrickHorizontalFillProportionalLinearLayout commentStamp: 'AliakseiSyrel 10/17/2014 10:37' prior: 0!
A GLMBrickHorizontalFillProportionalLinearLayout is a slight modification of ProportionalLayout but all elements have the same height and it is the same as parent's!

!GLMBrickHorizontalFillProportionalLinearLayout methodsFor: 'layouting' stamp: 'AliakseiSyrel 11/22/2014 16:27'!
extentOf: aBrick in: owner withArguments: aHashTable
	|extent|
	extent := super extentOf: aBrick in: owner withArguments: aHashTable.
	^ (extent x)@(owner brickInnerBounds height - aBrick layoutProperties verticalMargin)! !

!GLMBrickHorizontalProportionalLinearLayout class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 11/22/2014 16:36'!
example2

	|foundationBrick rootBrick brick1 brick2|
	
	rootBrick := GLMBrick new.
	rootBrick layoutPolicy: self new.
	
	rootBrick layoutProperties paddingLeft: 10.	
	rootBrick layoutProperties paddingTop: 10.
	rootBrick layoutProperties paddingRight: 10.	
	rootBrick layoutProperties paddingBottom: 10.
	rootBrick color: Color blue.
	
	brick1 := GLMBrick new.
	brick1 layoutProperties horizontalPercent: 100.
	brick1 extent: 50@70.
	brick1 color: Color red.
	
	brick2 := GLMBrick new.
	brick2 layoutProperties horizontalPercent: 0.
	brick2 layoutProperties minWidthBlock: [ 50 ].
	brick2 color: Color green.
	brick2 extent: 70@60.
	
	rootBrick
		addBrickBack: brick1;
		addBrickBack: brick2.
		
	foundationBrick := GLMFoundationBrick new.
	foundationBrick brickRoot: rootBrick.
	foundationBrick openInWindow.
	foundationBrick color: Color pink.
		
	
! !

!GLMBrickHorizontalProportionalLinearLayout methodsFor: 'layouting' stamp: 'AliakseiSyrel 11/27/2014 12:21'!
extentOf: aBrick in: owner withArguments: aHashTable
	| width requestedWidth allowedWidth minWidth maxWidth distributableWidth distributablePercents|
	
	minWidth := self minWidthOf: aBrick.
	maxWidth := self maxWidthOf: aBrick.
	distributableWidth := aHashTable at: #distributableWidth ifAbsent: [ owner brickInnerBounds width ].
	distributablePercents := aHashTable at: #distributablePercents ifAbsent: [ 100 ].
	
	allowedWidth := self widthOf: aBrick allowed: distributableWidth percents: distributablePercents.
	requestedWidth := self widthOf: aBrick allowed: owner brickInnerBounds width percents: 100.
	
	width := (requestedWidth < minWidth ifTrue: [ minWidth ] ifFalse: [ allowedWidth min: maxWidth ]) - aBrick layoutProperties horizontalMargin.
	
	^ width@(self originalHeightOf: aBrick)! !

!GLMBrickHorizontalProportionalLinearLayout methodsFor: 'set up' stamp: 'AliakseiSyrel 11/27/2014 12:18'!
prepareArgumentsFor: aBrick
	|allowedWidth maxPercent ownerWidth|
	
	ownerWidth := aBrick brickGlobalInnerBounds width.
	allowedWidth := ownerWidth.
	maxPercent := 100.
	
	aBrick subbricks do: [ :each |	|minWidth requestedWidth|
		minWidth := self minWidthOf: each.
		requestedWidth := self widthOf: each allowed: allowedWidth percents: maxPercent.
			
		requestedWidth < minWidth ifTrue: [ 
			allowedWidth := allowedWidth - minWidth.
			maxPercent := maxPercent - each layoutProperties horizontalPercent ] ].

	^ HashTable new
		add: (#distributableWidth -> allowedWidth);
		add: (#distributablePercents -> maxPercent);
		yourself! !

!GLMBrickHorizontalProportionalLinearLayout methodsFor: 'extent functions' stamp: 'AliakseiSyrel 11/22/2014 16:52'!
widthOf: aBrick allowed: width percents: percents

	percents <= 0 ifTrue: [ ^ 0 ].
	^ (width * aBrick layoutProperties horizontalPercent / percents) ceiling! !

!GLMBrickLayout class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 11/27/2014 20:57'!
example

	|foundationBrick rootBrick brick1 brick2 brick3|
	
	rootBrick := GLMBrick new.
	rootBrick layoutPolicy: self new.
	
	rootBrick layoutProperties paddingLeft: 10.	
	rootBrick layoutProperties paddingTop: 15.
	rootBrick layoutProperties paddingRight: 20.	
	rootBrick layoutProperties paddingBottom: 5.
	rootBrick color: Color blue.
	
	brick1 := GLMBrick new.
	brick1 layoutProperties marginLeft: 10.	
	brick1 layoutProperties marginTop: 15.	
	brick1 layoutProperties marginRight: 20.	
	brick1 layoutProperties marginBottom: 5.
	brick1 layoutProperties horizontalPercent: 30.
	brick1 layoutProperties verticalPercent: 30.
	brick1 extent: 50@70.
	brick1 color: Color red.
	
	brick2 := GLMBrick new.
	brick2 layoutProperties marginLeft: 10.	
	brick2 layoutProperties marginTop: 15.	
	brick2 layoutProperties marginRight: 20.
	brick2 layoutProperties marginBottom: 5.
	brick2 layoutProperties horizontalPercent: 50.
	brick2 layoutProperties verticalPercent: 50.
	brick2 color: Color green.
	brick2 extent: 70@60.
	
	brick3 := GLMBrick new.
	brick3 layoutProperties marginLeft: 10.	
	brick3 layoutProperties marginTop: 15.	
	brick3 layoutProperties marginRight: 20.	
	brick3 layoutProperties marginBottom: 5.
	brick3 layoutProperties horizontalPercent: 20.
	brick3 layoutProperties verticalPercent: 20.
	brick3 color: Color yellow.
	brick3 extent: 100@50.
	
	rootBrick
		addBrickBack: brick1;
		addBrickBack: brick2;
		addBrickBack: brick3.
		
	foundationBrick := GLMFoundationBrick new.
	foundationBrick brickRoot: rootBrick.
	foundationBrick openInWindow.
	foundationBrick color: Color pink.
! !

!GLMBrickLayout methodsFor: 'bounds' stamp: 'AliakseiSyrel 11/22/2014 16:25'!
boundsOf: aBrick in: owner withArguments: aHashTable
	
	^ (owner layoutProperties paddingLeft@owner layoutProperties paddingTop) extent: (self extentOf: aBrick in: owner withArguments: aHashTable)! !

!GLMBrickLayout methodsFor: 'layouting' stamp: 'AliakseiSyrel 11/22/2014 16:24'!
extentOf: aBrick in: owner withArguments: aHashTable
	
	^ (self originalWidthOf: aBrick)@(self originalHeightOf: aBrick)! !

!GLMBrickLayout methodsFor: 'reflection' stamp: 'AliakseiSyrel 11/27/2014 21:46'!
floatingMethodFor: aSymbol

	^ ('layoutFloating', (aSymbol capitalized), ':in:withArguments:') asSymbol.! !

!GLMBrickLayout methodsFor: 'layouting' stamp: 'AliakseiSyrel 10/17/2014 10:35'!
layout: aBrick in: newBounds
	self subclassResponsibility! !

!GLMBrickLayout methodsFor: 'layouting' stamp: 'AliakseiSyrel 11/27/2014 21:47'!
layoutFloating: aBrick in: newBounds withArguments: arguments
	"must return an integer that will be added to the offset, if necessary"
	
	|float symbol|
	float := aBrick layoutProperties floating.
	symbol := self floatingMethodFor: float.
	
	^ (self respondsTo: symbol)
		ifTrue: [ self perform: symbol with: aBrick with: newBounds with: arguments ]
		ifFalse: [ 0 ]! !

!GLMBrickLayout methodsFor: 'layouting' stamp: 'AliakseiSyrel 11/27/2014 21:35'!
layoutFloatingRight: aBrick in: newBounds withArguments: arguments

	| left top right bottom |
	
	left := aBrick owner width - aBrick width - aBrick layoutProperties marginRight.
	top := aBrick layoutProperties marginTop.
	right := aBrick owner width - aBrick layoutProperties marginRight.
	bottom := aBrick owner height - aBrick layoutProperties marginBottom.
	
	self setNewBounds: (GLMBrickLayoutBounds on: ((left@top) corner: right@bottom) of: aBrick) to: aBrick in: aBrick owner.
	
	^ 0! !

!GLMBrickLayout methodsFor: 'extent functions' stamp: 'AliakseiSyrel 11/22/2014 13:02'!
maxHeightOf: aBrick
	|blockValue|
	
	blockValue := aBrick layoutProperties maxHeightBlock cull: aBrick.
	
	^ (blockValue >= 0)
		ifTrue:[ blockValue ]
		ifFalse: [ SmallInteger maxVal ]! !

!GLMBrickLayout methodsFor: 'extent functions' stamp: 'AliakseiSyrel 11/22/2014 13:02'!
maxWidthOf: aBrick
	|blockValue|
	
	blockValue := aBrick layoutProperties maxWidthBlock cull: aBrick.
	
	^ (blockValue >= 0)
		ifTrue:[ blockValue ]
		ifFalse: [ SmallInteger maxVal ]! !

!GLMBrickLayout methodsFor: 'extent functions' stamp: 'AliakseiSyrel 11/22/2014 13:04'!
minHeightOf: aBrick
	|blockValue|
	
	blockValue := aBrick layoutProperties minHeightBlock cull: aBrick.
	
	^ (blockValue >= 0)
		ifTrue:[ blockValue ]
		ifFalse: [ SmallInteger minVal ]! !

!GLMBrickLayout methodsFor: 'extent functions' stamp: 'AliakseiSyrel 11/22/2014 13:04'!
minWidthOf: aBrick
	|blockValue|
	
	blockValue := aBrick layoutProperties minWidthBlock cull: aBrick.
	
	^ (blockValue >= 0)
		ifTrue:[ blockValue ]
		ifFalse: [ SmallInteger minVal ]! !

!GLMBrickLayout methodsFor: 'extent functions' stamp: 'AliakseiSyrel 11/22/2014 13:17'!
originalHeightOf: aBrick

	^ ((aBrick height) max: (self minHeightOf: aBrick)) min: (self maxHeightOf: aBrick).! !

!GLMBrickLayout methodsFor: 'extent functions' stamp: 'AliakseiSyrel 11/22/2014 13:16'!
originalWidthOf: aBrick

	^ ((aBrick width) max: (self minWidthOf: aBrick)) min: (self maxWidthOf: aBrick).! !

!GLMBrickLayout methodsFor: 'set up' stamp: 'AliakseiSyrel 11/22/2014 16:15'!
prepareArgumentsFor: aBrick

	^ nil! !

!GLMBrickLayout methodsFor: 'set up' stamp: 'AliakseiSyrel 12/1/2014 17:31'!
prepareLayout: aBrick

	aBrick isBrick ifTrue: [ aBrick onPrepareLayout ]! !

!GLMBrickLayout methodsFor: 'events' stamp: 'AliakseiSyrel 12/1/2014 17:30'!
sendEvent: aLayoutEvent to: aBrick

	aBrick isBrick ifTrue: [ aBrick onLayoutEvent: aLayoutEvent ]! !

!GLMBrickLayout methodsFor: 'bounds' stamp: 'AliakseiSyrel 12/1/2014 11:57'!
setNewBounds: aLayoutBounds to: aMorph in: aBrick

	aMorph isBrick
				ifTrue: [ aMorph brickBounds: aLayoutBounds bounds compressed ]
				ifFalse: [ aMorph bounds: (aLayoutBounds bounds translateBy: aBrick globalBounds origin) ].! !

!GLMBrickLayout methodsFor: 'reflection' stamp: 'AliakseiSyrel 12/2/2014 18:34'!
supportsFloating: aSymbol
	
	aSymbol = #none ifTrue: [ ^ false ].
	
	^ self respondsTo: (self floatingMethodFor: aSymbol)! !

!GLMBrickLayout methodsFor: 'bounds' stamp: 'AliakseiSyrel 12/1/2014 17:44'!
translate: aBrick by: anInteger

	self subclassResponsibility! !

GLMBrickLayout subclass: #GLMBrickNoLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Layouts'!

!GLMBrickNoLayout methodsFor: 'layouting' stamp: 'AliakseiSyrel 11/19/2014 20:17'!
layout: aBrick in: newBounds
	! !

GLMBrickLayout subclass: #GLMBrickVerticalLinearLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Layouts'!

!GLMBrickVerticalLinearLayout commentStamp: 'AliakseiSyrel 10/17/2014 21:56' prior: 0!
A GLMBrickVerticalLinearLayout is Linear layout, where all Bricks are being positioned vertically in one line. The size of Bricks depends only from each Brick's extent. If any Bricks goes outside of the parent with this layout, outside part will not be drawn.
!

GLMBrickVerticalLinearLayout subclass: #GLMBrickVerticalFillLinearLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Layouts'!

!GLMBrickVerticalFillLinearLayout commentStamp: 'AliakseiSyrel 10/17/2014 21:56' prior: 0!
A GLMBrickVerticalFillLinearLayout is Linear layout, where all Bricks are being positioned vertically in one line. The size of Bricks depends only from each Brick's extent. If any Bricks goes outside of the parent with this layout, outside part will not be drawn. The width of all elements in this layout is the same
!

GLMBrickVerticalFillLinearLayout subclass: #GLMBrickVerticalFillLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Layouts'!

!GLMBrickVerticalFillLayout methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/5/2014 07:16'!
boundsOf: aBrick in: owner withArguments: aHashTable
	
	^ (aBrick brickBounds origin) extent: (self extentOf: aBrick in: owner withArguments: aHashTable)! !

!GLMBrickVerticalFillLayout methodsFor: 'layouting' stamp: 'AliakseiSyrel 12/5/2014 07:15'!
layout: aBrick in: newBounds
	|arguments|
	arguments := self prepareArgumentsFor: aBrick.
	
	aBrick subbricks do: [:each |
			self prepareLayout: each.
			
			(self supportsFloating: each layoutProperties floating) ifFalse: [
				|layoutBounds|
			
				layoutBounds := GLMBrickLayoutBounds on: (self boundsOf: each in: aBrick withArguments: arguments) of: each.
				layoutBounds moveOuterToOrigin.
			
				self setNewBounds: layoutBounds to: each in: aBrick ]
			ifTrue: [ self layoutFloating: each in: newBounds withArguments: arguments ] ]! !

!GLMBrickVerticalFillLinearLayout methodsFor: 'layouting' stamp: 'AliakseiSyrel 12/1/2014 15:15'!
extentOf: aBrick in: owner withArguments: aHashTable
	
	^ (owner brickInnerBounds width - aBrick layoutProperties horizontalMargin)@(self originalHeightOf: aBrick)! !

GLMBrickVerticalFillLinearLayout subclass: #GLMBrickVerticalStackLayout
	instanceVariableNames: 'allowedBounds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Layouts'!

GLMBrickVerticalStackLayout subclass: #GLMBrickVerticalLinedStackLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Layouts'!

!GLMBrickVerticalLinedStackLayout methodsFor: 'testing' stamp: 'AliakseiSyrel 12/1/2014 18:26'!
isFullyVisible: aBrick
	
	^ self allowedBounds containsRect: aBrick brickGlobalOuterBounds! !

!GLMBrickVerticalLinedStackLayout methodsFor: 'testing' stamp: 'AliakseiSyrel 11/29/2014 13:16'!
isFullyVisible: aBrick in: aRectangle
	
	^ aRectangle containsRect: aBrick brickGlobalOuterBounds! !

!GLMBrickVerticalLinedStackLayout methodsFor: 'testing' stamp: 'AliakseiSyrel 12/1/2014 18:28'!
isPartiallyVisibleAbove: aBrick

	^ (self isFullyVisible: aBrick) not & (self isAbove: aBrick)! !

!GLMBrickVerticalLinedStackLayout methodsFor: 'testing' stamp: 'AliakseiSyrel 11/29/2014 13:20'!
isVisible: aBrick in: aRectangle
	
	^ aRectangle intersects: aBrick brickGlobalOuterBounds! !

!GLMBrickVerticalLinedStackLayout methodsFor: 'layouting' stamp: 'AliakseiSyrel 12/1/2014 17:40'!
layoutProportional: aCollection in: aBrick position: aSymbol
	| fullWidth eachWidth index |
	aCollection isEmpty ifTrue: [ ^ self ].
	
	fullWidth := aBrick brickInnerBounds width.
	index := 0.
	aCollection inject: aBrick layoutProperties paddingLeft into: [ :leftOffset :each |
		|layoutBounds|
		
		self sendEvent: (GLMBrickLayoutStacked new index: (index + 1); position: aSymbol; yourself) to: each.
		
		eachWidth := ((fullWidth - leftOffset) / (aCollection size - index)) ceiling.
		
		layoutBounds := GLMBrickLayoutBounds on: each brickBounds of: each.
		index = 0
			ifTrue: [ layoutBounds makeOuterBoundsFitWidth: (((self maxWidthOf: each) max: eachWidth) min: (fullWidth - leftOffset)) ]
			ifFalse: [				
				(index = (aCollection size - 1))
					ifFalse: [ layoutBounds makeOuterBoundsFitWidth: (eachWidth min: (self maxWidthOf: each)) ]
					ifTrue: [ layoutBounds makeOuterBoundsFitWidth: eachWidth ] ].
		
		layoutBounds translateBy: (leftOffset@0).
		self setNewBounds: layoutBounds to: each in: aBrick.
		index := index + 1.
		leftOffset + layoutBounds outerBounds width ]! !

!GLMBrickVerticalLinedStackLayout methodsFor: 'layouting' stamp: 'AliakseiSyrel 12/1/2014 18:32'!
layoutStacked: aBrick in: newBounds
	| origStackedBricks stackedBricks forward stackedTopBricks stackedBottomBricks stackedTopHeight stackedBottomHeight|

	self allowedBounds: newBounds.
	stackedBricks := self gatherStacked: aBrick.
	origStackedBricks := DoubleLinkedList new.
	origStackedBricks addAll: stackedBricks.
	forward := true.
	
	stackedTopHeight := 0.
	stackedBottomHeight := 0.
	stackedTopBricks := OrderedCollection new.
	stackedBottomBricks := OrderedCollection new.
	
	"going from top to bottom"
	[ stackedBricks isEmpty not & forward] whileTrue: [ |brick|
		brick := stackedBricks removeFirst value.
		(self isVisible: brick) ifFalse: [
			(self isAbove: brick) ifTrue: [ |delta|
				delta := (self deltaTop: brick) - stackedTopHeight.
				self translate: brick by: delta.
				self increaseZindex: brick.
				stackedTopBricks isEmpty ifTrue: [
					stackedTopHeight := stackedTopHeight + brick brickGlobalOuterBounds height.
					self cutAllowedBoundsTop: brick ].
				stackedTopBricks add: brick.
			] ifFalse: [ forward := false. stackedBricks addFirst: brick ]
		] ifTrue: [
			(self isPartiallyVisibleAbove: brick)
				ifTrue: [ self layoutAllowedTop: brick ]
				ifFalse: [ forward := false. self decreaseZindex: brick.	stackedBricks addFirst: brick ] ] ].

	"going from bottom to top"
	[ stackedBricks isEmpty not ] whileTrue: [ |brick|
		brick := stackedBricks removeLast value.
		(self isVisible: brick) ifFalse: [ |delta|
			delta := (self deltaBottom: brick) - stackedBottomHeight.
			self translate: brick by: delta negated.
			self increaseZindex: brick.
			stackedBottomBricks isEmpty ifTrue: [
				stackedBottomHeight := stackedBottomHeight + brick brickGlobalOuterBounds height.
				self cutAllowedBoundsBottom: brick ].
			stackedBottomBricks add: brick.
		] ifTrue: [
			(self isFullyVisible: brick )
				ifFalse: [ self layoutAllowedBottom: brick ]
				ifTrue: [ self decreaseZindex: brick ] ] ].

	self layoutProportional: stackedTopBricks reverse in: aBrick position: #top.
	self layoutProportional: stackedBottomBricks reverse in: aBrick position: #bottom.
	
	origStackedBricks do: [ :each | each doLayout ].
	
	^ allowedBounds! !

!GLMBrickVerticalStackLayout class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/1/2014 17:54'!
example
	"self example"
	|foundationBrick rootBrick brick1 brick2 brick3 brick4 brick5 brick6 generator|	
	
	rootBrick := GLMStackedScrollPaneBrick new.
	rootBrick band layoutPolicy: self new.
	rootBrick color: Color white.
	
	brick1 := GLMLabelBrick new.
	brick1 height: 30.
	brick1 text: 'Title 1'.
	brick1 textPosition: #center.
	brick1 layoutProperties floating: #stack.
	brick1 color: Color red.
	
	brick2 := GLMLabelBrick new.
	brick2 color: Color green.
	brick2 text: 'Title 2'.
	brick2 textPosition: #center.
	brick2 layoutProperties floating: #stack.
	brick2 height: 30.
	
	brick3 := GLMLabelBrick new.
	brick3 color: Color yellow.
	brick3 text: 'Title 3'.
	brick3 textPosition: #center.
	brick3 layoutProperties floating: #stack.
	brick3 height: 30.
	
	brick4 := GLMLabelBrick new.
	brick4 height: 30.
	brick4 text: 'Title 4'.
	brick4 textPosition: #center.
	brick4 layoutProperties floating: #stack.
	brick4 color: Color pink.
	
	brick5 := GLMLabelBrick new.
	brick5 color: Color orange.
	brick5 text: 'Title 5'.
	brick5 textPosition: #center.
	brick5 layoutProperties floating: #stack.
	brick5 height: 30.
	
	brick6 := GLMLabelBrick new.
	brick6 color: Color purple.
	brick6 text: 'Title 6'.
	brick6 textPosition: #center.
	brick6 layoutProperties floating: #stack.
	brick6 height: 30.
	
	generator:= [
		1 to: 10 do: [ :index | |brick|
			brick := GLMLabelBrick new.
			brick color: (Color random alpha: 0.2).
			brick height: 30.
			brick text: 'item',index asString.
			rootBrick addBrickBack: brick ] ].
	
	rootBrick addBrickBack: brick1.
	generator value.
	
	rootBrick addBrickBack: brick2.
	generator value.
	
	rootBrick addBrickBack: brick3.
	generator value.
	
	rootBrick addBrickBack: brick4.
	generator value.
	
	rootBrick addBrickBack: brick5.
	generator value.
	
	rootBrick addBrickBack: brick6.
	generator value.
		
	foundationBrick := GLMFoundationBrick new.
	foundationBrick brickRoot: rootBrick.
	foundationBrick extent: 400@400.
	foundationBrick openInWindow.
	foundationBrick color: Color pink.
! !

!GLMBrickVerticalStackLayout methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/1/2014 17:57'!
allowedBounds
	^ allowedBounds! !

!GLMBrickVerticalStackLayout methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/1/2014 17:57'!
allowedBounds: anObject
	allowedBounds := anObject! !

!GLMBrickVerticalStackLayout methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/1/2014 17:59'!
cutAllowedBoundsBottom: aBrick

	self allowedBounds: (self shrinkBottom: self allowedBounds with: aBrick )! !

!GLMBrickVerticalStackLayout methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/1/2014 17:59'!
cutAllowedBoundsTop: aBrick

	self allowedBounds: (self shrinkTop: self allowedBounds with: aBrick )! !

!GLMBrickVerticalStackLayout methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/1/2014 17:55'!
decreaseZindex: aBrick

	aBrick layoutProperties zIndex: 1.! !

!GLMBrickVerticalStackLayout methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/1/2014 18:03'!
deltaBottom: aBrick

	^ aBrick brickGlobalOuterBounds corner y -  self allowedBounds corner y! !

!GLMBrickVerticalStackLayout methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/1/2014 18:03'!
deltaTop: aBrick

	^ self allowedBounds origin y - aBrick brickGlobalOuterBounds origin y! !

!GLMBrickVerticalStackLayout methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 11/27/2014 21:51'!
gatherStacked: aBrick
	|list|
	
	list := DoubleLinkedList new.
	aBrick subbricks do: [ :each | each layoutProperties floating = #stack ifTrue: [ list add: each ] ].
	^ list! !

!GLMBrickVerticalStackLayout methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/1/2014 17:55'!
increaseZindex: aBrick

	aBrick layoutProperties zIndex: 2.! !

!GLMBrickVerticalStackLayout methodsFor: 'testing' stamp: 'AliakseiSyrel 12/1/2014 18:01'!
isAbove: aBrick

	^ aBrick brickGlobalOuterBounds origin <= self allowedBounds origin! !

!GLMBrickVerticalStackLayout methodsFor: 'testing' stamp: 'AliakseiSyrel 11/27/2014 22:47'!
isAbove: aBrick in: aRectangle

	^ aBrick brickGlobalOuterBounds origin <= aRectangle origin! !

!GLMBrickVerticalStackLayout methodsFor: 'testing' stamp: 'AliakseiSyrel 12/1/2014 18:01'!
isVisible: aBrick
	
	^ self allowedBounds containsRect: aBrick brickGlobalOuterBounds! !

!GLMBrickVerticalStackLayout methodsFor: 'testing' stamp: 'AliakseiSyrel 11/27/2014 23:03'!
isVisible: aBrick in: aRectangle
	
	^ aRectangle containsRect: aBrick brickGlobalOuterBounds! !

!GLMBrickVerticalStackLayout methodsFor: 'layouting' stamp: 'AliakseiSyrel 12/1/2014 12:00'!
layout: aBrick in: newBounds
	
	super layout: aBrick in: newBounds.
	^ self layoutStacked: aBrick in: newBounds! !

!GLMBrickVerticalStackLayout methodsFor: 'layouting' stamp: 'AliakseiSyrel 12/1/2014 18:19'!
layoutAllowedBottom: aBrick

	self
		translate: aBrick by: (self deltaBottom: aBrick) negated;
		increaseZindex: aBrick;
		cutAllowedBoundsBottom: aBrick! !

!GLMBrickVerticalStackLayout methodsFor: 'layouting' stamp: 'AliakseiSyrel 12/1/2014 18:18'!
layoutAllowedTop: aBrick

	self
		translate: aBrick by: (self deltaTop: aBrick);
		increaseZindex: aBrick;
		cutAllowedBoundsTop: aBrick! !

!GLMBrickVerticalStackLayout methodsFor: 'layouting' stamp: 'AliakseiSyrel 12/1/2014 18:24'!
layoutStacked: aBrick in: newBounds
	| stackedBricks forward|

	self allowedBounds: newBounds.
	stackedBricks := self gatherStacked: aBrick.
	forward := true.
	
	"going from top to bottom"
	[ stackedBricks isEmpty not & forward] whileTrue: [ |brick|
		brick := stackedBricks first value.
		(self isVisible: brick) ifFalse: [
			(self isAbove: brick) ifTrue: [
				self layoutAllowedTop: brick.
				stackedBricks removeFirst.
			] ifFalse: [ forward := false ]
		] ifTrue: [ forward := false. self decreaseZindex: brick ] ].

	"going from bottom to top"
	stackedBricks reverseDo: [ :brick |
		(self isVisible: brick)
			ifFalse: [ self layoutAllowedBottom: brick ]
			ifTrue: [ self decreaseZindex: brick ] ].

	^ allowedBounds! !

!GLMBrickVerticalStackLayout methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/1/2014 17:54'!
shrinkBottom: aRectangle with: aBrick

	^ aRectangle bottom: (aRectangle bottom - aBrick brickGlobalOuterBounds height)! !

!GLMBrickVerticalStackLayout methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/1/2014 17:51'!
shrinkTop: aRectangle with: aBrick

	^ aRectangle top: (aRectangle top + aBrick brickGlobalOuterBounds height)! !

!GLMBrickVerticalLinearLayout methodsFor: 'layouting' stamp: 'AliakseiSyrel 12/1/2014 17:32'!
layout: aBrick in: newBounds
	|arguments|
	arguments := self prepareArgumentsFor: aBrick.
	
	aBrick subbricks
		inject: 0
		into: [ :topOffset :each |
			self prepareLayout: each.
			
			(self supportsFloating: each layoutProperties floating) ifFalse: [
				|layoutBounds|
			
				layoutBounds := GLMBrickLayoutBounds on: (self boundsOf: each in: aBrick withArguments: arguments) of: each.
				layoutBounds translateBy: (0@topOffset).
				layoutBounds moveOuterToOrigin.
			
				self setNewBounds: layoutBounds to: each in: aBrick.
			
				topOffset + layoutBounds outerBounds height ]
			ifTrue: [ topOffset + (self layoutFloating: each in: newBounds withArguments: arguments) ] ]! !

!GLMBrickVerticalLinearLayout methodsFor: 'bounds' stamp: 'AliakseiSyrel 12/1/2014 17:44'!
translate: aBrick by: anInteger

	aBrick brickBounds: (aBrick brickBounds translateBy: 0@anInteger)! !

GLMBrickVerticalLinearLayout subclass: #GLMBrickVerticalProportionalLinearLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Layouts'!

!GLMBrickVerticalProportionalLinearLayout commentStamp: 'AliakseiSyrel 10/18/2014 12:57' prior: 0!
A GLMBrickVerticalProportionalLinearLayout is an improvement of standard VerticalLinearLayout such that element are positioned proportionaly in the parent based on Brick>>layoutProperties verticalPercent.
!

GLMBrickVerticalProportionalLinearLayout subclass: #GLMBrickVerticalFillProportionalLinearLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Layouts'!

!GLMBrickVerticalFillProportionalLinearLayout commentStamp: 'AliakseiSyrel 10/18/2014 12:57' prior: 0!
A GLMBrickVerticalFillProportionalLinearLayout is a slight modification of VerticalProportionalLayout but all elements have the same width and it is the same as parent's!

!GLMBrickVerticalFillProportionalLinearLayout methodsFor: 'layouting' stamp: 'AliakseiSyrel 11/22/2014 16:43'!
extentOf: aBrick in: owner withArguments: aHashTable
	|extent|
	extent := super extentOf: aBrick in: owner withArguments: aHashTable.
	^ (owner brickInnerBounds width - aBrick layoutProperties horizontalMargin)@(extent y)! !

!GLMBrickVerticalProportionalLinearLayout methodsFor: 'layouting' stamp: 'AliakseiSyrel 11/22/2014 16:42'!
extentOf: aBrick in: owner withArguments: aHashTable
	| height requestedHeight allowedHeight minHeight maxHeight distributableHeight distributablePercents|
	
	minHeight := self minHeightOf: aBrick.
	maxHeight := self maxHeightOf: aBrick.
	distributableHeight := aHashTable at: #distributableHeight ifAbsent: [ owner brickInnerBounds height ].
	distributablePercents := aHashTable at: #distributablePercents ifAbsent: [ 100 ].
	
	allowedHeight := self heightOf: aBrick allowed: distributableHeight percents: distributablePercents.
	requestedHeight := self heightOf: aBrick allowed: owner brickInnerBounds width percents: 100.
	
	height := (requestedHeight < minHeight ifTrue: [ minHeight ] ifFalse: [ allowedHeight min: maxHeight ]) - aBrick layoutProperties verticalMargin.
	
	^ (self originalWidthOf: aBrick)@height! !

!GLMBrickVerticalProportionalLinearLayout methodsFor: 'extent functions' stamp: 'AliakseiSyrel 11/22/2014 16:53'!
heightOf: aBrick allowed: height percents: percents

	percents <= 0 ifTrue: [ ^ 0 ].
	^ (height * aBrick layoutProperties verticalPercent / percents) ceiling! !

!GLMBrickVerticalProportionalLinearLayout methodsFor: 'set up' stamp: 'AliakseiSyrel 11/22/2014 16:54'!
prepareArgumentsFor: aBrick
	|allowedHeight maxPercent ownerHeight|
	
	ownerHeight := aBrick brickGlobalInnerBounds height.
	allowedHeight := ownerHeight.
	maxPercent := 100.
	
	aBrick subbricks do: [ :each |	|minHeight requestedHeight|
		minHeight := self minHeightOf: each.
		requestedHeight := self heightOf: each allowed: ownerHeight percents: 100.
			
		requestedHeight < minHeight ifTrue: [ 
			allowedHeight := allowedHeight - minHeight.
			maxPercent := maxPercent - each layoutProperties verticalPercent ] ].

	^ HashTable new
		add: (#distributableHeight -> allowedHeight);
		add: (#distributablePercents -> maxPercent);
		yourself! !

Announcement subclass: #GLMBrickAnnouncement
	instanceVariableNames: 'data'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Announcements'!

!GLMBrickAnnouncement commentStamp: 'AliakseiSyrel 10/17/2014 10:11' prior: 0!
A GLMBrickAnnouncement is default announcement used for any purpose by bricks.

Instance Variables
	data:		<Object>

data
	- xxxxx
!

!GLMBrickAnnouncement methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 16:22'!
data
	^ data! !

!GLMBrickAnnouncement methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 16:22'!
data: anObject
	data := anObject! !

GLMBrickAnnouncement subclass: #GLMBrickDataChanged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Announcements'!

!GLMBrickDataChanged commentStamp: 'AliakseiSyrel 10/17/2014 10:11' prior: 0!
A GLMBrickDataChanged is fired when GLMBrick>>data is changed
!

GLMBrickAnnouncement subclass: #GLMBrickLayoutEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Announcements'!

GLMBrickLayoutEvent subclass: #GLMBrickLayoutStacked
	instanceVariableNames: 'index position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Announcements'!

!GLMBrickLayoutStacked methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/1/2014 17:34'!
index
	^ index! !

!GLMBrickLayoutStacked methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/1/2014 17:34'!
index: anObject
	index := anObject! !

!GLMBrickLayoutStacked methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/1/2014 17:35'!
position
	^ position! !

!GLMBrickLayoutStacked methodsFor: 'accessing' stamp: 'AliakseiSyrel 12/1/2014 17:35'!
position: anObject
	position := anObject! !

DoubleLinkedList subclass: #GLMBrickDoubleLinkedList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Utils'!

!GLMBrickDoubleLinkedList methodsFor: 'enumerating' stamp: 'AliakseiSyrel 11/27/2014 17:43'!
inject: thisValue into: binaryBlock 
	"Accumulate a running value associated with evaluating the argument, 
	binaryBlock, with the current value of the argument, thisValue, and the 
	receiver as block arguments. For instance, to sum the numeric elements 
	of a collection, aCollection inject: 0 into: [:subTotal :next | subTotal + 
	next]."

	| nextValue |
	nextValue := thisValue.
	self do: [:each | nextValue := binaryBlock value: nextValue value: each].
	^nextValue! !

!Color class methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 11/29/2014 17:39'!
colorFromRGBInteger: anInteger
	|red green blue|
	
	blue := (anInteger >> 16) & 16r0ff.
	green := (anInteger >> 8) & 16r0ff.
	red := anInteger & 16r0ff.	
	
	^ self r: red g: green b: blue range: 255.
! !

!Color methodsFor: '*Glamour-Morphic-Brick' stamp: 'AliakseiSyrel 11/29/2014 17:27'!
asRGBInteger

	^(self red * 255) asInteger + ((self green * 255) asInteger << 8) + ((self blue * 255) asInteger << 16)! !

Object subclass: #GLMBrickAbstractAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Model'!

!GLMBrickAbstractAdaptor commentStamp: 'AliakseiSyrel 12/6/2014 18:59' prior: 0!
A GLMBrickAbstractAdaptor is an interface for all adapters to be used with brick lazy widgets!

!GLMBrickAbstractAdaptor methodsFor: 'adaptor api' stamp: 'AliakseiSyrel 12/6/2014 18:50'!
count

	self subclassResponsibility! !

!GLMBrickAbstractAdaptor methodsFor: 'adaptor api' stamp: 'AliakseiSyrel 12/6/2014 18:53'!
morphAt: anInteger convert: aMorph

	self subclassResponsibility! !

GLMBrickAbstractAdaptor subclass: #GLMBrickListAdaptor
	instanceVariableNames: 'origin countLogic morphLogic'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Model'!

!GLMBrickListAdaptor commentStamp: 'AliakseiSyrel 12/6/2014 20:04' prior: 0!
A GLMBrickListAdaptor is scriptable implementation of adapter that is mostly used with list scroll brick

Instance Variables
	countLogic:		<Object>
	morphLogic:		<Object>
	origin:		<Object>

countLogic
	- xxxxx

morphLogic
	- xxxxx

origin
	- xxxxx
!

!GLMBrickListAdaptor class methodsFor: 'instance creation' stamp: 'AliakseiSyrel 12/6/2014 19:53'!
on: anObject

	^ self new on: anObject! !

!GLMBrickListAdaptor methodsFor: 'adaptor api' stamp: 'AliakseiSyrel 12/6/2014 19:49'!
count

	^ countLogic
		ifNil: [ origin size ]
		ifNotNil: [ countLogic cull: origin ] ! !

!GLMBrickListAdaptor methodsFor: 'adaptor api' stamp: 'AliakseiSyrel 12/6/2014 20:03'!
morphAt: anInteger convert: aMorph

	^ morphLogic
		ifNil: [ (origin at: anInteger) asMorph ]
		ifNotNil: [
			morphLogic isSymbol
				ifTrue: [ origin perform: morphLogic withEnoughArguments: { anInteger . aMorph }  ]
				ifFalse: [ morphLogic cull: anInteger cull: aMorph ] ]! !

!GLMBrickListAdaptor methodsFor: 'instance creation' stamp: 'AliakseiSyrel 12/6/2014 19:59'!
morphAtLogic: aBlockWithTwoParameters

	morphLogic := aBlockWithTwoParameters! !

!GLMBrickListAdaptor methodsFor: 'instance creation' stamp: 'AliakseiSyrel 12/6/2014 20:00'!
on: anObject

	origin := anObject! !

!GLMBrickListAdaptor methodsFor: 'instance creation' stamp: 'AliakseiSyrel 12/6/2014 19:59'!
sizeLogic: aBlockWithNoParameters

	countLogic := aBlockWithNoParameters! !

Object subclass: #GLMBrickLayoutBounds
	instanceVariableNames: 'outerBounds bounds innerBounds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Layouts'!

!GLMBrickLayoutBounds class methodsFor: 'construction' stamp: 'AliakseiSyrel 11/22/2014 13:31'!
on: aRectangle of: aBrick

	^ self new on: aRectangle of: aBrick! !

!GLMBrickLayoutBounds methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/22/2014 17:39'!
bounds
	^ bounds ifNil: [ bounds := 0@0 extent: 0@0 ]! !

!GLMBrickLayoutBounds methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/22/2014 17:40'!
innerBounds
	^ innerBounds ifNil: [ innerBounds := 0@0 extent: 0@0 ]! !

!GLMBrickLayoutBounds methodsFor: 'actions' stamp: 'AliakseiSyrel 12/1/2014 14:18'!
makeBoundsAsOuter

	bounds := outerBounds! !

!GLMBrickLayoutBounds methodsFor: 'actions' stamp: 'AliakseiSyrel 12/1/2014 14:10'!
makeBoundsFitWidth: anInteger
	|delta|
	
	delta := bounds width - anInteger.
	outerBounds := outerBounds withRight: (outerBounds right - delta).
	innerBounds := innerBounds withRight: (innerBounds right - delta).
	bounds := bounds withRight: (bounds right - delta).
	! !

!GLMBrickLayoutBounds methodsFor: 'actions' stamp: 'AliakseiSyrel 11/29/2014 13:10'!
makeOuterBoundsFitWidth: anInteger
	|delta|
	
	delta := outerBounds width - anInteger.
	outerBounds := outerBounds withRight: (outerBounds right - delta).
	innerBounds := innerBounds withRight: (innerBounds right - delta).
	bounds := bounds withRight: (bounds right - delta).
	! !

!GLMBrickLayoutBounds methodsFor: 'actions' stamp: 'AliakseiSyrel 11/22/2014 17:40'!
moveOuterToOrigin

	self translateBy: (self bounds origin - self outerBounds origin).! !

!GLMBrickLayoutBounds methodsFor: 'construction' stamp: 'AliakseiSyrel 11/22/2014 17:38'!
on: aRectangle of: aBrick
	|left top right bottom|
	
	aRectangle ifNil: [ ^ self ].
	
	bounds := aRectangle.
	
	left := bounds origin x.
	top := bounds origin y.
	right := bounds corner x.
	bottom := bounds corner y.
	
	innerBounds := ((left + aBrick layoutProperties paddingLeft)@(top + aBrick layoutProperties paddingTop)) corner: ((right - aBrick layoutProperties paddingRight)@(bottom - aBrick layoutProperties paddingBottom)).
	outerBounds := ((left - aBrick layoutProperties marginLeft)@(top - aBrick layoutProperties marginTop)) corner: ((right + aBrick layoutProperties marginRight)@(bottom + aBrick layoutProperties marginBottom)).! !

!GLMBrickLayoutBounds methodsFor: 'accessing' stamp: 'AliakseiSyrel 11/22/2014 17:40'!
outerBounds
	^ outerBounds ifNil: [ outerBounds := 0@0 extent: 0@0 ]! !

!GLMBrickLayoutBounds methodsFor: 'actions' stamp: 'AliakseiSyrel 11/22/2014 17:40'!
translateBy: aPoint

	bounds := self bounds translateBy: aPoint.
	innerBounds := self innerBounds translateBy: aPoint.
	outerBounds := self outerBounds translateBy: aPoint.! !

Object subclass: #GLMBrickRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Renderer'!

!GLMBrickRenderer commentStamp: 'AliakseiSyrel 10/17/2014 10:33' prior: 0!
A GLMBrickRenderer is most simple separate renderer of Bricks. It support only borders
!

!GLMBrickRenderer class methodsFor: 'rendering' stamp: 'AliakseiSyrel 10/17/2014 10:35'!
render: aBrick on: aCanvas

	self renderBorderOf: aBrick on: aCanvas.! !

!GLMBrickRenderer class methodsFor: 'rendering' stamp: 'AliakseiSyrel 10/17/2014 10:35'!
renderBorderOf: aBrick on: aCanvas
	|rect|
	
	rect := (aBrick brickBounds origin - (aBrick layoutProperties paddingLeft @ aBrick layoutProperties paddingTop)) corner: (aBrick brickBounds corner + (aBrick layoutProperties paddingRight @ aBrick layoutProperties paddingBottom)).

	aCanvas frameRectangle: rect width: aBrick borderWidth color: aBrick borderColor! !

!GLMBrickRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 10/17/2014 10:34'!
render: aBrick on: aCanvas

	self class render: aBrick on: aCanvas! !

!GLMBrickRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 10/17/2014 10:34'!
renderBorderOf: aBrick on: aCanvas

	self class renderBorderOf: aBrick on: aCanvas.! !

GLMBrickRenderer subclass: #GLMGaussianBlurBrickRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Renderer'!

!GLMGaussianBlurBrickRenderer class methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/3/2014 21:33'!
example

	|morph|
	morph := GLMFoundationBrick new.
	morph brickRoot renderer: self new.
	morph extent: 300@300.
	morph openCenteredInWorld color: Color transparent.
	morph color: Color transparent.
	morph borderWidth: 3.
	morph borderColor: Color gray.
	morph wantsToBeTopmost! !

!GLMGaussianBlurBrickRenderer methodsFor: 'algorithm' stamp: 'AliakseiSyrel 12/3/2014 20:26'!
boxBlur: scl dest: tcl width: w height: h radius: r

	1 to: scl size do: [ :i | tcl at: i put: (scl at: i) ].
	self boxBlurH: tcl dest: scl width: w height: h radius: r.
	self boxBlurT: scl dest: tcl width: w height: h radius: r
! !

!GLMGaussianBlurBrickRenderer methodsFor: 'algorithm' stamp: 'AliakseiSyrel 12/3/2014 21:14'!
boxBlurH: scl dest: tcl width: w height: h radius: mR
	|iarr r|
	
	r := (w min: h)/2 < (mR) ifTrue: [ ^ self ] ifFalse: [ mR ].
	
   iarr := 1.0 / (r+r+1).

	0 to: (h-1) do: [ :i |
		|ti li ri fv lv val|
		ti := i * w.
		li := ti.
		ri := ti + r.
		fv := scl at: (ti+1).
		lv := scl at: (ti + w).
		val := (r+1)*fv.
		0 to: (r-1) do: [ :j | val := val + (scl at: (ti+j+1)) ].
		
		0 to: r do: [ :j |
			val := val + (scl at: (ri+1)) - fv.
			tcl at: (ti+1) put: ((val*iarr)).
			ri := ri + 1.
			ti := ti + 1 ].
		
		(r+1) to: (w-r-1) do: [ :j |
			val := val + (scl at: (ri+1)) - (scl at: (li+1)).
			tcl at: (ti+1) put: ((val*iarr)).
			li := li + 1.
			ri := ri + 1.
			ti := ti + 1 ].
		
		(w-r) to: (w-1) do: [ :j |
			val := val + lv - (scl at: (li+1)).
			tcl at: (ti+1) put: ((val*iarr)).
			li := li + 1.
			ti := ti + 1 ] 	]
! !

!GLMGaussianBlurBrickRenderer methodsFor: 'algorithm' stamp: 'AliakseiSyrel 12/3/2014 21:14'!
boxBlurT: scl dest: tcl width: w height: h radius: mR
	|iarr r|
	
	r := (w min: h)/2 < (mR) ifTrue: [ ^ self ] ifFalse: [ mR ].
	
   iarr := 1.0 / (r+r+1).

	0 to: (w-1) do: [ :i |
		|ti li ri fv lv val|
		ti := i.
		li := ti.
		ri := ti + (r*w).
		fv := scl at: (ti+1).
		lv := scl at: (ti+(w*(h-1))+1).
		val := (r+1)*fv.
		
		0 to: (r-1) do: [ :j | val := val + (scl at:(ti+(j*w))+1) ].
		
		0 to: r do: [ :j |
			val := val + (scl at: (ri+1)) - fv.
			tcl at: (ti+1) put: ((val*iarr)).
			ri := ri + w.
			ti := ti + w ].
		
		(r+1) to: (h-r-1) do: [ :j |
			val := val + (scl at: (ri+1)) - (scl at: (li+1)).
			tcl at: (ti+1) put: ((val*iarr)).
			li := li + w.
			ri := ri + w.
			ti := ti + w ].
		
		(h-r) to: (h-1) do: [ :j |
			val := val + lv - (scl at: (li+1)).
			tcl at: (ti+1) put: ((val*iarr)).
			li := li + w.
			ti := ti + w ] 	]
! !

!GLMGaussianBlurBrickRenderer methodsFor: 'algorithm' stamp: 'AliakseiSyrel 11/29/2014 16:41'!
boxesForGauss: sigma count: n
	"standard deviation, number of boxes"

	| wIdeal wl wu mIdeal m sizes |
	wIdeal := (12 * sigma * sigma / n + 1) sqrt.	"Ideal averaging filter width"
	wl := wIdeal floor.
	wl % 2 = 0
		ifTrue: [ wl := wl - 1 ].
	wu := wl + 2.
	mIdeal := (12 * sigma * sigma - (n * wl * wl) - (4 * n * wl) - (3 * n)) / (-4 * wl - 4).
	m := mIdeal rounded.
	sizes := OrderedCollection new: n.
	1 to: n do: [ :i | 
		sizes
			add:
				(i < m
					ifTrue: [ wl ]
					ifFalse: [ wu ]) ].
	^ sizes! !

!GLMGaussianBlurBrickRenderer methodsFor: 'algorithm' stamp: 'AliakseiSyrel 12/3/2014 21:14'!
gaussBlur: scl dest: tcl width: w height: h radius: r
	|bxs|
	
	bxs := self boxesForGauss: r count: 3.
	self boxBlur: scl dest: tcl width: w height: h radius: (bxs first asFloat - 1)/2.
	self boxBlur: tcl dest: scl width: w height: h radius: (bxs second asFloat - 1)/2.
	self boxBlur: scl dest: tcl width: w height: h radius: (bxs third asFloat - 1)/2

! !

!GLMGaussianBlurBrickRenderer methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/3/2014 18:43'!
getChannelsFrom: aForm

	! !

!GLMGaussianBlurBrickRenderer methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/3/2014 19:02'!
putChannelValuesFromPixelValue: p depth: d r: mR g: mG b: mB a: mA at: index
	"Convert a pixel value for the given display depth into a color."
	"Details: For depths of 8 or less, the pixel value is simply looked up in a table. For greater depths, the color components are extracted and converted into a color."
	| r g b alpha |
	d = 8 ifTrue: [ ^ self putColorInChannels: (Color indexedColors at: (p bitAnd: 255) + 1) r: mR g: mG b: mB a: mA at: index ].
	d = 4 ifTrue: [ ^ self putColorInChannels: (Color indexedColors at: (p bitAnd: 15) + 1) r: mR g: mG b: mB a: mA at: index ].
	d = 2 ifTrue: [ ^ self putColorInChannels: (Color indexedColors at: (p bitAnd: 3) + 1) r: mR g: mG b: mB a: mA at: index ].
	d = 1 ifTrue: [ ^ self putColorInChannels: (Color indexedColors at: (p bitAnd: 1) + 1) r: mR g: mG b: mB a: mA at: index ].
	d = 16 | (d = 15) ifTrue: 
		[ "five bits per component"
		r := (p bitShift: -10) bitAnd: 31.
		g := (p bitShift: -5) bitAnd: 31.
		b := p bitAnd: 31.
		(r = 0 and: [ g = 0 ]) ifTrue: 
			[ b = 0 ifTrue: [ ^ self putColorInChannels: (Color transparent) r: mR g: mG b: mB a: mA at: index ].
			b = 1 ifTrue: [ ^ self putColorInChannels: (self black) r: mR g: mG b: mB a: mA at: index ] ].
		^ self putRGBChannelsRed: r green: g blue: b alpha: 31.0 range: 31.0 r: mR g: mG b: mB a: mA at: index ].
	d = 32 ifTrue: 
		[ "eight bits per component; 8 bits of alpha"
		r := (p bitShift: -16) bitAnd: 255.
		g := (p bitShift: -8) bitAnd: 255.
		b := p bitAnd: 255.
		alpha := p bitShift: -24.
		alpha = 0 ifTrue: [ ^ self putColorInChannels: (Color transparent) r: mR g: mG b: mB a: mA at: index ].
		(r = 0 and: [ g = 0 and: [ b = 0 ] ]) ifTrue: [ ^ self putColorInChannels: (Color transparent) r: mR g: mG b: mB a: mA at: index ].
		alpha < 255 
			ifTrue: 
				[ ^ self putRGBChannelsRed: r green: g blue: b alpha: alpha range: 255.0 r: mR g: mG b: mB a: mA at: index ]
			ifFalse:
				[ ^ self putRGBChannelsRed: r green: g blue: b alpha: 255.0 range: 255.0 r: mR g: mG b: mB a: mA at: index ] ].
	d = 12 ifTrue: 
		[ "four bits per component"
		r := (p bitShift: -8) bitAnd: 15.
		g := (p bitShift: -4) bitAnd: 15.
		b := p bitAnd: 15.
		^ self putRGBChannelsRed: r green: g blue: b alpha: 15.0 range: 15.0 r: mR g: mG b: mB a: mA at: index ].
	d = 9 ifTrue: 
		[ "three bits per component"
		r := (p bitShift: -6) bitAnd: 7.
		g := (p bitShift: -3) bitAnd: 7.
		b := p bitAnd: 7.
		^ self putRGBChannelsRed: r green: g blue: b alpha: 7.0 range: 7.0 r: mR g: mG b: mB a: mA at: index ].
	self error: 'unknown pixel depth: ' , d printString! !

!GLMGaussianBlurBrickRenderer methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/3/2014 19:06'!
putColorInChannels: aColor r: r g: g b: b a: a at: index
	
	r atWrap: index put: aColor red.
	g atWrap: index put: aColor green.
	b atWrap: index put: aColor blue.
	a atWrap: index put: aColor alpha.! !

!GLMGaussianBlurBrickRenderer methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/3/2014 18:59'!
putRGBChannelsRed: red green: green blue: blue alpha: alpha range: range r: r g: g b: b a: a at: index
	
	r atWrap: index put: (red asFloat/range).
	g atWrap: index put: (green asFloat/range).
	b atWrap: index put: (blue asFloat/range).
	a atWrap: index put: (alpha asFloat/range).! !

!GLMGaussianBlurBrickRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 12/3/2014 21:13'!
render: aBrick on: aCanvas
	| origin corner height width  poker form formDest r g b a depth destR destG destB destA|
	
	height := aCanvas privateClipRect height.
	width := aCanvas privateClipRect width.
	poker := aCanvas privatePort.
		
	origin := aCanvas origin.
	corner := aCanvas privateClipRect corner.
	
	
	form := aCanvas form copy: aCanvas privateClipRect.
	depth := form depth.
	formDest := Form extent: form extent depth: form depth.
	
	r := Array new: form bits size.
	g := Array new: form bits size.
	b := Array new: form bits size.
	a := Array new: form bits size.
	
	destR := Array new: form bits size.
	destG := Array new: form bits size.
	destB := Array new: form bits size.
	destA := Array new: form bits size.
	
	form bits doWithIndex: [ :each :index | self putChannelValuesFromPixelValue: each depth: depth r: r g: g b: b a: a at: index ].
	
	self gaussBlur: r dest: destR width: form width height: form height radius: 5.
	self gaussBlur: g dest: destG width: form width height: form height radius: 5.
	self gaussBlur: b dest: destB width: form width height: form height radius: 5.
"	self gaussBlur_4: a dest: destA width: form width height: form height radius: 4."
	
	self storeChannelsRed: destR green: destG blue: destB alpha: a in: formDest bits depth: depth.
	
	aCanvas drawImage: formDest at: (aCanvas clipRect origin).
	super render: aBrick on: aCanvas! !

!GLMGaussianBlurBrickRenderer methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/3/2014 19:29'!
storeChannelsRed: r green: g blue: b alpha: a in: aBitmap depth: depth

	1 to: aBitmap size do: [ :index | aBitmap integerAt: index put: (self toPixelValueRed: (r atWrap: index)  green: (g atWrap: index) blue: (b atWrap: index) alpha: (a atWrap: index) depth: depth )  ]! !

!GLMGaussianBlurBrickRenderer methodsFor: 'as yet unclassified' stamp: 'AliakseiSyrel 12/3/2014 19:27'!
toPixelValueRed: r green: g blue: b alpha: a depth: depth

	^ (Color r: r g: g b: b alpha: a) pixelValueForDepth: depth! !

GLMBrickRenderer subclass: #GLMInteractableBrickRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Renderer'!

!GLMInteractableBrickRenderer commentStamp: 'AliakseiSyrel 10/17/2014 10:34' prior: 0!
A GLMInteractableBrickRenderer is more advanced Brick renderer, that is used in all interactable Bricks to allow on-fly change of background color or image
!

!GLMInteractableBrickRenderer class methodsFor: 'rendering' stamp: 'AliakseiSyrel 10/17/2014 10:34'!
render: aBrick on: aCanvas
	
	self renderColorOf: aBrick on: aCanvas.
	self renderImageOf: aBrick on: aCanvas.
	self renderBorderOf: aBrick on: aCanvas.! !

!GLMInteractableBrickRenderer class methodsFor: 'rendering' stamp: 'AliakseiSyrel 10/17/2014 10:34'!
renderColorOf: aBrick on: aCanvas
	|color|
	
	color := aBrick currentColor.
	color ifNotNil: [ aCanvas fillRectangle: aBrick brickBounds color: color ].! !

!GLMInteractableBrickRenderer class methodsFor: 'rendering' stamp: 'AliakseiSyrel 10/17/2014 10:34'!
renderImageOf: aBrick on: aCanvas
	|image|
	
	image := aBrick currentImage.
	
	image ifNotNil: [
		aCanvas 
			translucentImage: (GLMBrick resizeImage: image scale: (aBrick extent / image extent))
			at: aBrick brickBounds origin.
	].! !

!GLMInteractableBrickRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 10/17/2014 10:34'!
render: aBrick on: aCanvas
	
	self renderColorOf: aBrick on: aCanvas.
	self renderImageOf: aBrick on: aCanvas.! !

!GLMInteractableBrickRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 10/17/2014 10:34'!
renderColorOf: aBrick on: aCanvas
	self class renderColorOf: aBrick on: aCanvas! !

!GLMInteractableBrickRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 10/17/2014 10:34'!
renderImageOf: aBrick on: aCanvas
	self class renderImageOf: aBrick on: aCanvas! !

GLMInteractableBrickRenderer subclass: #GLMRoundButtonBrickRenderer
	instanceVariableNames: 'isRoundedLeft isRoundedRight antialiasing'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Brick-Renderer'!

!GLMRoundButtonBrickRenderer commentStamp: 'AliakseiSyrel 11/20/2014 11:44' prior: 0!
A GLMRoundButtonBrickRenderer allows to render a button with rounded corners. Uses TrachelCanvas to support antialiasing

Instance Variables
	antialiasing:		<Object>
	isRoundedLeft:		<Object>
	isRoundedRight:		<Object>

antialiasing
	- xxxxx

isRoundedLeft
	- xxxxx

isRoundedRight
	- xxxxx
!

!GLMRoundButtonBrickRenderer methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 13:52'!
antialiasing

	^ antialiasing! !

!GLMRoundButtonBrickRenderer methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 13:52'!
antialiasing: aBoolean

	antialiasing := aBoolean! !

!GLMRoundButtonBrickRenderer methodsFor: 'drawing' stamp: 'AliakseiSyrel 10/4/2014 13:52'!
drawCircle: radius position: aPoint on: aCanvas color: aColor antialiasing: isAntialiased
	
	isAntialiased
		ifTrue: [ self drawTrachelCircle: radius position: aPoint on: aCanvas color: aColor ]
		ifFalse: [ self drawMorphicCircle: radius position: aPoint on: aCanvas color: aColor ]
	! !

!GLMRoundButtonBrickRenderer methodsFor: 'drawing' stamp: 'AliakseiSyrel 10/4/2014 13:52'!
drawMorphicCircle: radius position: aPoint on: aCanvas color: aColor

	aCanvas fillOval: (Rectangle origin: aPoint extent: ((2*radius)@(2*radius))) color: aColor borderWidth: 0 borderColor: Color transparent.! !

!GLMRoundButtonBrickRenderer methodsFor: 'drawing' stamp: 'AliakseiSyrel 10/4/2014 13:52'!
drawTrachelCanvas: trachelCanvas at: aPoint on: aCanvas
	|surface|
	
	surface := AthensCairoSurface extent: (trachelCanvas extent) asIntegerPoint.
	
	surface drawDuring: [:cs |
		surface clear.
		trachelCanvas shapes do: [ :trachelShape |
			trachelShape drawOn: cs.
		].
	].

	aCanvas image: surface asForm at: aPoint sourceRect: (0 @ 0 extent: surface extent) rule: 34.! !

!GLMRoundButtonBrickRenderer methodsFor: 'drawing' stamp: 'AliakseiSyrel 10/4/2014 13:52'!
drawTrachelCircle: radius position: aPoint on: aCanvas color: aColor
			
	self drawTrachelCanvas: (
		TRCanvas new addShape: (
			TRArcShape new
				color: aColor;
				alphaAngle: 0  betaAngle: 360  innerRadius: 0 externalRadius: radius;
				translateBy: radius @ radius
		)
	) at: aPoint on: aCanvas.! !

!GLMRoundButtonBrickRenderer methodsFor: 'initialization' stamp: 'AliakseiSyrel 10/4/2014 13:52'!
initialize
	super initialize.
	
	self isRoundedLeft: false.
	self isRoundedRight: false.
	self antialiasing: true.! !

!GLMRoundButtonBrickRenderer methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 13:52'!
isRoundedLeft
	^ isRoundedLeft! !

!GLMRoundButtonBrickRenderer methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 13:52'!
isRoundedLeft: anObject
	isRoundedLeft := anObject! !

!GLMRoundButtonBrickRenderer methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 13:52'!
isRoundedRight
	^ isRoundedRight! !

!GLMRoundButtonBrickRenderer methodsFor: 'accessing' stamp: 'AliakseiSyrel 10/4/2014 13:52'!
isRoundedRight: anObject
	isRoundedRight := anObject! !

!GLMRoundButtonBrickRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 11/20/2014 11:59'!
renderColorOf: aBrick on: aCanvas
	|rectangle radius diameter bounds|
	
	bounds := aBrick brickBounds.
		
	radius := (aBrick height / 2) roundDownTo: 1.0.
	diameter := radius * 2.
	rectangle := bounds withHeight: diameter.
	
	self isRoundedLeft ifTrue: [ 
		self drawCircle: radius position: bounds topLeft on: aCanvas color: aBrick currentColor antialiasing: self antialiasing.
		rectangle := (rectangle withWidth: rectangle width - radius) translateBy: radius@0.
	].

	self isRoundedRight ifTrue: [
		self drawCircle: radius position: bounds topRight - (diameter@0) on: aCanvas color: aBrick currentColor antialiasing: self antialiasing.
		rectangle := rectangle withWidth: rectangle width - radius.
	].
	
	aCanvas fillRectangle: rectangle basicFillStyle: (SolidFillStyle color: aBrick currentColor).! !
